
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau2t.h"
// #import "nxardn2t.h"
#import <math.h> 
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern char ascrule[KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK];
extern char ascrulo[KK][KK][KK];

int    drawBack=YES;
int    drawEvol=NO;
int    drawLine=NO;
int    drawPlane=NO;
int    drawMosaic=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawTMatrix=NO;
int    drawPlaid=NO;

int    drawview=0;

int    ardnl, ardnll;
int    repPlEv;
int    xpos[3]={0,100,0};

int    plaidline[2];
void   wrru(char *c, char ar[KK][KK][KK][KK]);


int    save1[20][20], save2[20][20], save3[20][20];
int    cu=12;

extern char   arule[DS], arr1[AL], arr2[AL];

extern int    co, dn;

extern NXColor colst[KK];

extern void procur(int e, int g);
void egraf(int x,int y,int n);
   
@implementation LCAUView


void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

       if (l<2) NXSetColor(colst[l]);
  else if (l==2) NXSetColor(NX_COLORBLUE);
  else if (l>2) NXSetColor(NX_COLORBLACK);
 
    switch (drawview) {
    case 0: 
	PSrectfill((float)((2*AL-i+2*j)%(2*AL)),2.0*(float)i,1.25,1.25); break;
    case 1: PSrectfill(2.0*(float)j,200.0-2.0*(float)i,1.25,1.25); break;
    case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
    case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
    case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(2.5*(float)j,2.5*(float)i,9.0,9.0); break;
      case 7: PSrectfill(4.0*(float)j,4.0*(float)i,3.125,3.125); break;
      case 8: PSrectfill(150.0+(float)j,260.0-(float)i,1.0,1.0); break;
      case 9: PSrectfill(2.0*(float)j,173.0-2.0*(float)i,1.5,1.5); break;
      case 10: PSrectfill((float)j,(float)i,3.125,3.125); break;
      case 11: PSrectfill((float)j,(float)i,1.0,1.0); break;
      default: break;}
}

/*  m = line length; n = number of lines   */
/* Version for use with half-integer radii */
void shortevolve(m,n) int m, n; {
int i, j, k, l, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    k=j%2; l=j/2;
    for (i=0; i<m; i++) videodot(4*j,4*i-2*k,arr1[(YL+i+o+l)%YL]);
    onegen(YL);
    }
  renewarry();
}

/* index three dimensions */
int inx3(i,j,k) int i, j, k; {return (cu+i)%cu+ cu*((cu+j)%cu+ cu*((cu+k)%cu ));}

void drawsquare() {int i, j;
  for (i=0; i<128; i++) for (j=0; j<128; j++) videodot(j,i,arr1[i*128+j]);
}

void drawcube() {int i, j, k;
  for (i=0; i<32; i++) for (j=0; j<32; j++) for (k=0; k<16; k++) 
    videodot(j+32*(k/4),i+32*(k%4),arr1[ix3(i,j,k)]);
}

void manysquare(i,j) int i, j; {int k, l;
  for (k=0; k<128; k++) for (l=0; l<128; l++)  
    videodot(k+128*i,l+128*j,arr1[ix2(k,l)]);
}

void drawgrid() {int i;
	  PSsetgray(NX_BLACK); 
	  PSsetlinewidth(0.1);
  for (i=0; i<5; i++) {
  PSmoveto((double)(128.0*i),0.0); PSlineto((double)(128.0*i),512.0);}
  for (i=0; i<5; i++) {
  PSmoveto(0.0,(double)(128.0*i)); PSlineto(512.0,(double)(128.0*i));}
  PSstroke();
}

/* --------------------------- E V O L U T I O N --------------------------- */

/* evWindow decides which evolutionary window to display, based */
/* on the dimension of the automaton, which in turn depends on  */
/* how the neighborhood's volume can be factorized		*/

- evWindow:sender {  switch (dn) {
     case 1:  [ev1Window makeKeyAndOrderFront: sender];
	      [ev2Window performClose: sender];
	      [ev3Window performClose: sender];
	      break;
     case 2:  [ev2Window makeKeyAndOrderFront: sender];
	      [ev1Window performClose: sender];
	      [ev3Window performClose: sender];
	      break;
     default: [ev3Window makeKeyAndOrderFront: sender];
	      [ev1Window performClose: sender];
	      [ev2Window performClose: sender];
	      break;}
  return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
  return self;
}

- drawShEvol:sender {
    drawview=10;
    drawShort=YES;
    [self display];
    drawShort=NO;
return self;
}

- printShEvol:sender {
  drawview=10;
  drawShort=YES;
  [keyWindow smartPrintPSCode: self];
  drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==plEvolWindow)  [self printPlEvol:  sender];
    if (keyWindow==shEvolWindow)  [self printShEvol:  sender];
    if (keyWindow==thEvolWindow)  [self printThEvol:  sender];
    if (keyWindow==evolWindow)    [self printEvolu:   sender];
    if (keyWindow==plaidWindow)   [self printPlaid:   sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=10;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=0;
  drawEvol=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theEvolView getBounds: &zbounds];
  [theEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawEvol=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==thEvolWindow)  [self copyThEvol: sender];
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==plaidWindow)   [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender{
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode:self];
  drawEvol=NO;
return self;
}

- drawPlEvol:sender {int i;
  repPlEv=[[sender selectedCell] tag];
  drawview=7;
  drawPlane=YES;
  asctobin();
  if (repPlEv==0) [self display]; else
    for (i=0; i<repPlEv; i++) {
      [genEv setIntValue: i];
      onegen(AL);
      [self display];
      }
  [genEv setIntValue: repPlEv];
  drawPlane=NO;
return self;
}

- printPlEvol:sender {
    repPlEv=0;
    drawview=7;
    drawPlane=YES;
    [keyWindow smartPrintPSCode: self];
    drawPlane=NO;

return self;
}

- drawMosaic:sender {
  drawview=11;
  drawMosaic=YES;
  [self display];
  drawMosaic=NO;
return self;
}

- printMosaic:sender {
  drawview=11;
  drawMosaic=YES;
  [keyWindow smartPrintPSCode: self];
  drawMosaic=NO;
return self;
}

/* -------------------------------- L C A U -------------------------------- */

/* -------------------------------- R I J N -------------------------------- */

/* -------------------------------- P R O B -------------------------------- */

/* --------------------------   L C A U    V I E W   ----------------------- */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate: 
		floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = 
		[NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];


  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

  [self setFlipped: YES];

	return self;

}

- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML], ch[40];
	int		 i, j, k=0, n;
        double           p, q, s, dp, r;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

        if (drawEvol==YES && dn==1) {
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
	 if ([keepTop state]){printf("savearry\n"); savearry();}
	  evolve(0);
	  if ([keepTop state]){printf("renewarry\n");renewarry();}
	  }

         if (drawShort==YES && dn==1) {
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
   	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}  

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

/*--------------------  plaid ----------------------*/
	
	if (drawPlaid==YES) {		/* one cycle of evolution */
		 n=[[gridSize selectedCell] tag];
		 if( strcmp([[aSwitch selectedCell] title], "distance")==0) {
			[ruleNumber setStringValue: "distance matrix"];
			for(i=0; i<256; i++) for(j=0; j<256; j++) {
				r= tdist(i, j, 8);
			    	PSsetcmykcolor(0.1*r, 0.8*r, 1.0-r, 0.55*r);
				PSrectfill((float)(j), (float)(i),1.0,1.0);
				}
			PSstroke();
			}	
		 if( strcmp([[aSwitch selectedCell] title], "circles")==0) {
			needsClearing = YES;
			[points empty];
		sprintf(c,"center : %3d,  %3d \n", plaidline[0],plaidline[1]);
		printf("center : %3d,  %3d \n", plaidline[0],plaidline[1]);
			[ruleNumber setStringValue: c];
			for(i=0; i<256; i++) for(j=0; j<256; j++) {
				p= tdist(i, plaidline[1], 8);
				q= tdist(j, plaidline[0], 8);
				s =(p+q);
				PSsetcmykcolor(s, 0.05*p, 1.0-s, 0.05*q);
				PSrectfill((float)(j), (float)(i),1.0,1.0);
				}
			PSstroke();
			PSsetgray(NX_BLACK);
	PSrectfill((float)(plaidline[0]),(float)(plaidline[1]), 2.0, 2.0);
			PSstroke();
			}				
		 if( strcmp([[aSwitch selectedCell] title], "plaid")==0) {
			wrru(c,ascrule);
			[ruleNumber setStringValue: c];
			savearry();
			asctobin();
			for(j=0; j<128; j++) {
				ranlin(0.5);
				for(i=0; i<64; i++) {onegen(AL); pprob(); }
				}
			renewarry();
		}
		
		if(n>0) {
		PSsetgray(NX_BLACK);
		PSsetlinewidth(0.0);
		    for (j=1, dp=256.0, i=0; i<n; i++) {j*=2; dp*=0.5;}
		    for (i=0, p=1.0; i<j+1; i++, p+=dp) {
			PSmoveto(0.1,p);
			PSlineto(256.0,p);
			PSmoveto(p,0.1);
			PSlineto(p,256.0);
			}
		    PSstroke();
		    }
		}

/*------------------------------------------------*/

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

        if (drawPlane==YES) {
   switch (dn) {
     case 2: 
	[window setTitle: "Moore (2,1/2) Plane Evolution"];
	drawsquare();
	break;
     case 3: 
	[window setTitle: "3-D face centered cubic Evolution"];
	drawcube();
	drawgrid();
	break;
     case 5: 
	[window setTitle: "von Neumann (2,2) Plane Evolution"];
	drawsquare();
	break;
     default: [window setTitle: "LCAU2T Plane Evolution"];break;}
	}

        if (drawMosaic==YES) {
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
   switch (dn) {
     case 2: 
	[window setTitle: "Moore (2,H) manysquare Plane Evolution"];
	for (i=0; i<4; i++) for (j=0; j<4; j++) {
	  manysquare(i,j);
	  onegen(AL);
	  [window flushWindow];
	  }
	drawgrid();
	break;
     case 5: 
	[window setTitle: "von Neumann (2,H) manysquare Plane Evolution"];
	for (i=0; i<4; i++) for (j=0; j<4; j++) {
	  manysquare(i,j);
	  onegen(AL);
	  [window flushWindow];
	  }
	drawgrid();
	break;
     default: [window setTitle: "LCAU24 Plane Evolution"];break;}
	}

	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==7||drawview==6||drawview==10) 
		{[self setDrawOrigin:0 :0]; return self;}
	else 
		[self setDrawOrigin:-floor(width/2) : -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events. As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;
   	char	buffer[100];

         double  ex, wy;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(
		&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {looping = NO;}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

/* end LCAUView.m */
