   
#import "RulePanel.h"
#import "nxlcau2t.h"
#import <string.h>
#import <time.h>
#import "rec.h"

extern int  binrule[KK][KK][KK][KK];
extern int  co, dn;			/* connectivity, dimension  */
extern char arr1[AL], arr2[AL];
extern char ascrule[KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK];
extern char gf2rule[13];		/* coefficients of GF2 rule */
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK+1][TS-1];

void    asctobin();
void    asctotot();
void	asczero();
void	auxzero();
void    chrucopy(char ii[KK][KK][KK][KK], char jj[KK][KK][KK][KK], char c);
void    clumin(char *c);
int     cyy(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
void    granptotrule();
void    grantotrule();
int     istot();
int     isstot();
void    nutoto(int i);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0, double p1);
void    ranplacor();
void    ransolcor();
void    ranvachrul(char *c);
void    rule2t();
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    tazero();
void    ttzero();
void    wolftoasc(int n);
void    zerline();

void 	defineWrule(long int WW);
void    wrru(char *c, char ru[KK][KK][KK][KK]);
void	xtoasc(int n);

extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
int     ycc(int i);

NXColor colst[KK];

void bincopy(birular *rz, int rx[KK][KK][KK][KK]);
void binprint(birular rz);
void binprod(birular *rz, birular rx, birular ry);
void binsum(birular *rz, birular rx, birular ry);
void bintoasc();

void auxiliar(birular *first,int *second);
void llena_matriz(birular rx,birular ry);

char    xr[DS] = "0011001100110011";
char    xp[DS] = "1333333333333332";
char    xq[DS] = "2122112211221121";

int permu[RSYM/2][KK] = {
			{0, 1},
			{1, 0}
			};

int aritmetic=0;

extern struct 	fptbl dtbl[];
extern Inst 	xprg[][XLEN];
extern char	idef[][30];

int vecperm(int ii[KK], int n);
int allperm(char wn[RSYM][5],
	    char ii[][KK][KK][KK][KK],
	    char ru[KK][KK][KK][KK]);
int longwolftoasc(char *c);
void numtobin2h(long int ru[KK][KK],long int  n);


@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  [speshPanel makeKeyAndOrderFront: sender];
  nowSpesh=[speshPanel contentView];
  ch=[[sender selectedCell] title];
printf("loadSpecialRule: %s\n",ch);
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"Arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"Composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"Symmetries")==0)  {
	[self loadLowerPanel: symmRuleBox];
	nowSpesh=symBox;
	}
  if (strcmp(ch,"Totalistic")==0)  {
	[self loadLowerPanel: totlRuleBox];
	nowSpesh=toBox;
	}
//  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
//  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
 id cv;
 cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",(int)[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
  [speshPanel setDocEdited: NO];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender
{int i, j, k, i0, i1, i2,i3;
  i=j=[sender selectedCol];
  i3=i%KK; i/=KK;
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2][i3];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2][i3]=!k;
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
char  ii[RSYM][KK][KK][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int l, k, j, jj[KK];
  k= 0;
  l= allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
        if (strcmp(titl,"keep")==0)       k=0;
   else if (strcmp(titl,"complement")==0) k=1;
   else if (strcmp(titl,"cluster")==0)    k=RSYM;
   else if (strcmp(titl,"reflected")==0)  k=2;
   else if (strcmp(titl,"least")==0)      k=l;
   else if (strcmp(titl,"both")==0)       k=3;
   else					  k=0;
   if (k==RSYM) {
     clumin(c);
     longwolftoasc(c);
     [self setAllRules: self];
     return self;
     }
   chrucopy(ascrule,ii[k],'w');
   [self setAllRules: self];
   if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}

int allperm(wn,ii,ru) 
	char wn[][WNML], ii[][KK][KK][KK][KK], ru[KK][KK][KK][KK]; { 
int  k, l;
  chrucopy(ii[0],ru,'w'); 
  chrucopy(ii[1],ru,'y'); 
  chrucopy(ii[2],ii[0],'r');   
  chrucopy(ii[3],ii[1],'r');   
  for(k=0, l=0; k<RSYM; k++) {
    wrru(wn[k],ii[k]);
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
  return l;
 } 

int vecperm(ii,n) int ii[KK], n; 
{  int i,k,l;
   l=!(n < 2); k=(l ? n-2: n);
   switch(k) {
        case 0 : for(i=0; i < KK ;i++) ii[i]=i; break;
        case 1 : for(i=0; i < KK ;i++) ii[i]=ycc(i); break;
        default: for(i=0; i < KK ;i++) ii[i]=i; break;  
        }
    return l;
  }

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<DS; i++) pr->one[i]=permu[k][br->one[i]];
}


/* for 2-state automata, group the neighborhoods by fours and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	       */
void wrru(c,ru) char *c, ru[KK][KK][KK][KK]; {
int  i, i0, i1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  i= 4*(2*(ru[i0][i1][1][1]-'0')+(ru[i0][i1][1][0]-'0'))+
        2*(ru[i0][i1][0][1]-'0')+(ru[i0][i1][0][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-KK*i0-i1-2]=i;
  }
c[WNML-1]=0;
}

void wru(c) char *c; {wrru(c,ascrule);}

void defineWrule(ww) long int ww;{
int       i0, i1, i2, i3;
for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
         for (i2=0; i2<KK; i2++) 
	    for (i3=0; i3<KK; i3++)
        	    {ascrule[i0][i1][i2][i3]='0'+ww%KK; ww/=KK;}
}

int cyy(i) int i; 
  {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case  0: return   1;
	case  1: return   0; 
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case  0: return   1;
	case  1: return   0; 
	default:  return '0';}
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, i3, j0, j1, r;
j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) 
     for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++) 
           for (i3=0; i3<KK; i3++){
             j0=KK+i1-i0;
             j1=KK+i2-i1;
             r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
             r+=j0*j1*(j11+j0*j21+j1*j12);
             r+=j0*j0*j1*j1*j22;
            switch([[sIncr selectedCell] tag]) {
             case 0: r+=i0; break;
             case 1: r+=i1; break;
             case 2: r+=i2; break;
	     case 3: r+=i3; break;
             case 4: r+=(KK-i0)+(KK-i1); break;
             case 5: r+=(KK-i1)+(KK-i2); break;
             case 6: r+=(KK-i2)+(KK-i3); break;
	     case 7: r+=(KK-i3)+(KK-i0); break;
             case 8: break;
             default: break;}
    ascrule[i3][i2][i1][i0]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }

- readTRule:sender {
  nutoto([sender intValue]);
  totoasc();
  [self setAllRules: self];
return self;}

- readWRule:sender {
  wolftoasc([sender intValue]);
  [self setAllRules: self];
return self;}

void wolftoasc(n) int n; {int k, i0, i1, i2, i3;
  k=n;
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    {ascrule[i0][i1][i2][i3]='0'+k%KK; k/=KK;}
}

/* create the wolfram rule number by reading ascrule */
int asctowolf() {int  k, i0, i1, i2, i3;
  k=0;
  for (i0=KK-1; i0>=0; i0--)
  for (i1=KK-1; i1>=0; i1--)
  for (i2=KK-1; i2>=0; i2--)
  for (i3=KK-1; i3>=0; i3--)
    k=2*k+(ascrule[i0][i1][i2][i3]-'0');
  return k;
}

int longwolftoasc (char *c) {
char d[WNML], e;
int i, i0, i1, l, n;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'f') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'F') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    n=d[KK*KK-i0*KK-i1-1];
    ascrule[i0][i1][0][0]='0'+n%KK; n/=KK;
    ascrule[i0][i1][0][1]='0'+n%KK; n/=KK;
    ascrule[i0][i1][1][0]='0'+n%KK; n/=KK;
    ascrule[i0][i1][1][1]='0'+n%KK;
    }
  return TRUE;
}

- readHxRule:sender {
  char *c;
   c=(char *)[sender stringValue];
   if(longwolftoasc(c))  [self setAllRules: self]; 
    else  [ruleNumberH setStringValue: "invalid"];
  return self;  
}

- setRule:sender 
{char ch[WNML]; int i, ii, j, jj, i0, i1, i2,i3;
   wrru(ch,ascrule);
   [ruleNumberH setStringValue: ch];
   [ruleNumberD setIntValue: asctowolf()];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i3=j%KK; j/=KK;  
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2][i3]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender 
{char ch[WNML]; int i, j, i0, i1, i2,i3;
   wrru(ch,ascrule);
   [ruleNumberH setStringValue: ch];
   [ruleNumberD setIntValue: asctowolf()];
  asctobin();
  for (i0=0; i0<KK; i0++) 
     for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++)
           for (i3=0; i3<KK; i3++) {
         j=KK*(KK*(KK*i0+i1)+i2)+i3;                                                                                                                                                                                                               
         for (i=0; i<KK; i++) {
           [[ascru cellAt: i: j] setIntValue: NO];
           if (auxrule[i0][i1][i2][i3]) [[ascru cellAt: i: j] setEnabled: NO];
           if (auxrule[i0][i1][i2][i3]) [[ascru cellAt: i: j] setBordered: NO];
           }
        [[ascru cellAt: binrule[i0][i1][i2][i3]: j] setIntValue: YES];
    }
   wrru(ch,ascrule);
   [ruleNumberH setStringValue: ch];
   [ruleNumberD setIntValue: asctowolf()];
   [probView loadProb: self];
   if      (istot()) [totlRef setStringValue: "totalistic"]; 
      else [totlRef setStringValue: " "];
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random rule */
void granrule() {int i, i0, i1, i2,i3;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
         for (i3=0; i3<KK; i3++){
            i=(random()&0xFF)%KK;
	    ascrule[i0][i1][i2][i3]=i+'0';
	    //  printf("%d",i);
  }
//  printf("\n");
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2,i3, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
	 for (i3=0; i3<KK; i3++){
            if (i%8 == 0) j=random();  i++;
  	    if (auxrule[i0][i1][i2][i3]==0) ascrule[i0][i1][i2][i3]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- rCellLine:sender {double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1]);
return self;
}

- sCellLine:sender {
  zerline();
  switch (dn) {
    case 1: putionj(1,0); break;
    case 2: ranplacor(); break;
    case 3: ransolcor(); break;
    case 5: ranplacor(); break;
    case 6: ransolcor(); break;
    default: putionj(1,0); break;}
return self;
}

- uCellLine:sender {ranblin(0.5,0.5); return self;}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[WNML];
   wrru(ch,ascrule);
   [ruleNumberH setStringValue: ch];
   [ruleNumberD setIntValue: asctowolf()];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - - - -   G F ( 2 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf2rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF2Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf2rule[i]); printf("\n");
    gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {
  int s, t,i;
    s=[sender selectedRow];
    t=[sender tag];
    if ([sender tag]==0) {
      for (i=0; i<KK; i++)
	{
           [[sem0 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	 [[sem0 cellAt: s: [sender selectedCol]] setIntValue: YES];
    }
    if ([sender tag]==1) {
      for (i=0; i<KK; i++)
	{
           [[sem1 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
           [[sem1 cellAt: s: [sender selectedCol]] setIntValue: YES];
       } 
    if ([sender tag]==2) {
      for (i=0; i<KK; i++)
	{
           [[sem2 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	   [[sem2 cellAt: s: [sender selectedCol]] setIntValue: YES];

    }


    strule[t][[sender selectedCol]]=s+'0';
    [stWindow setDocEdited:YES];
    //sttoasc(); 
  return self;
  }

- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [speshPanel setDocEdited: NO];
return self;
}

- protectTotRule:sender {int i, j, k;
    j=[sender selectedCol];
    k=tarule[j];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setEnabled:  k];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setBordered: k];
    tarule[j]=!k;
return self;
}

- setTotRule:sender {int i, j, ii, jj;
  ii= [sender selectedRow];
  jj= [sender selectedCol];
  ttrule[jj]='0'+ii;
  for (i=0; i<KK; i++) [[toascru cellAt: i: jj] setIntValue: NO];
  [[toascru cellAt: ii: jj] setIntValue: YES];
  [toRuleNumber setIntValue: totonu(0)];
  [speshPanel setDocEdited: YES];
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  return self;
}

- freeAllTotRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    tazero();
return self;
}

- zeroTotRules:sender 
    {ttzero(); tazero(); totoasc(); [self setTotRules: self]; return self;}

- ranTotRules:sender {grantotrule(); [self setTotRules: self]; return self;}

- ranPTotRules:sender {granptotrule(); [self setTotRules: self]; return self;}

/* generate a random protected totalistic rule */
void granptotrule() {int i0, i, j;
i=0; j=0;
for (i0=0; i0<TS; i0++) {
          if (i%8 == 0) j=random();  i++;
  	  if (tarule[i0]==0) ttrule[i0]='0'+j%KK;
	  j/=KK;
	  }
}

/* generate a random totalistic rule */
void grantotrule() {int i0, i, j;
i=0; j=0;
for (i0=0; i0<TS; i0++) {
          if (i%8 == 0) j=random();  i++;
  	  ttrule[i0]='0'+j%KK;
	  j/=KK;
	  }
}

/* clear ttrule to zeroes */
void ttzero() {int i; for (i=0; i<TS; i++)  ttrule[i]='0';}

/* clear tarule to zeroes */
void tazero() {int i; for (i=0; i<TS; i++)  tarule[i]=0;}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule switch (c[KK*(KK*i0+i1)+i2]-'0') {*/
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i, j;
i=j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
     for (i2=0; i2<KK; i2++) 
        for (i3=0; i3<KK; i3++){
           switch (c[j]-'0') {
            	case 0: break;
    		case 1: i=0; break;
    		case 2: i=1; break;
    		case 3: i=ran2of3(0,1); break;
    	        default: i=0; break;}
	  j++; 	
    	  ascrule[i0][i1][i2][i3]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2, i3;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) 
     for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++) 
           for (i3=0; i3<KK; i3++){
    [z setIntValue: ascrule[i0][i1][i2][i3]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2, i3;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i3=k%KK; k/=KK;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1][i2][i3]=(k<KK?k:0)+'0';
    auxrule[i0][i1][i2][i3]=(k<KK?1:0);
    }
  [self setAllRules: self];
return self;
}

/*     - - - - - - - - -  ARITHMETIC COMBINATION  - - - -  - - - */

 - arithmCombs:sender {
int i0,i1,i2,i3;
birular aza, bzb, czc;
   [self readWRule: [twoRules cellAt: 0: 0]];
   asctobin();
   bincopy(&aza,binrule);
   binprint(aza);
   [self readWRule: [twoRules cellAt: 1: 0]];
   asctobin();
   bincopy(&bzb,binrule);
   binprint(bzb);
   switch ([sender selectedRow]) {
      case 0: binsum(&czc,aza,bzb); break;
      case 1: binprod(&czc,aza,bzb); break;
      default: printf("arithCombs\n"); 
   break;}
   binprint(czc);
   for (i0=0; i0<KK ;i0++) 
      for (i1=0; i1<KK ;i1++) 
	 for (i2=0; i2<KK ;i2++) 
	    for (i3=0; i3<KK; i3++)
               binrule[i0][i1][i2][i3]=czc.four[i0][i1][i2][i3]; 
   bintoasc();
   [self setAllRules: self];
return self;
}

- initTwoRules:sender {
char ch[WNML];
   granrule();
   wrru(ch,ascrule);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz; int rx[KK][KK][KK][KK];
{int i0, i1, i2, i3;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
               rz->four[i0][i1][i2][i3]=rx[i0][i1][i2][i3]+'0';
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/*fill ascrule from binrule*/
void bintoasc()
{int i0, i1, i2, i3;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
               ascrule[i0][i1][i2][i3]=binrule[i0][i1][i2][i3]+'0';
}

/*sum two binary rules mod KK*/
void binsum(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*multiply two binary rules mod KK*/
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*print a binary rules (all 16 numbers)*/
void binprint(rz) birular rz;
{int i;
      for (i=0; i<KK*KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
      printf("\n");
}

- useRecLine:sender; {
  [RECPanel makeKeyAndOrderFront:sender];
  [RECValue setStringValue: "*"];
  return self;
}

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}



/* ================   c o m p o s i t e   r u l e    ============= */

  - composRule:sender
  { long int ru1, ru2, ru3, br1[KK][KK], br2[KK][KK], br3[KK][KK];
    int  i0, i1, i2, i3;
     ru1=[[compRuleNumb cellAt: 0: 0] intValue];
     ru2=[[compRuleNumb cellAt: 1: 0] intValue];
     ru3=[[compRuleNumb cellAt: 2: 0] intValue];
     numtobin2h(br1, ru1);
     numtobin2h(br2, ru2);
     numtobin2h(br3, ru3);
     for(i0=0; i0<KK; i0++) 
      for(i1=0; i1<KK; i1++) 
       for(i2=0; i2<KK; i2++)
        for(i3=0; i3<KK; i3++)
          ascrule[i0][i1][i2][i3] = br3[br2[br1[i0][i1]][br1[i1][i2]]][br2[br1[i1][i2]][br1[i2][i3]]] + '0';
     [self setAllRules: self];
     return self;
    }

   - compxRule:sender
   {long int i;
      i= [[compRuleNumb cellAt: 0: 0] intValue];
      [[compRuleNumb cellAt: 0: 0] setIntValue :
                       [[compRuleNumb cellAt: 1: 0] intValue]];
      [[compRuleNumb cellAt: 1: 0] setIntValue :
                       [[compRuleNumb cellAt: 2: 0] intValue]];

     [[compRuleNumb cellAt: 2: 0] setIntValue: i];
     return self;
     }

   - comprRule:sender 
    {
       [[compRuleNumb cellAt: 0: 0] setIntValue: random()% 16];
       [[compRuleNumb cellAt: 1: 0] setIntValue: random()% 16];
       [[compRuleNumb cellAt: 2: 0] setIntValue: random()% 16];
      return self;

      }

   void numtobin2h(ru, n) long int ru[KK][KK], n;
  { int i, j, i0, i1;
    i=n;
      for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) {
        j=i%KK; i/=KK;
        ru[i0][i1] = j;
        }
    }

@end

/* end RulePanel.m */
