
/* lcau2t.h			*/
/* header file for lcau2t.c	*/
/* 12 May 1989			*/

# define COLGRAF		4  /* graph resolution			*/
# define T80X25			3  /* text resolution			*/
# define WHCYMAG		1  /* color quad for normal screen	*/
# define YELREGR		2  /* alternative color palette 	*/
# define CR		        5  /* cursor reference - row editor	*/
# define CM		        7  /* cursor reference - main menu	*/
# define CL		       11  /* cursor reference - line editor	*/
# define AL      	    16384  /* array length (screen width)	*/
# define SL		       40  /* short array length		*/
# define YL		      320  /* screen length (normally 320)	*/
# define KK	     		2  /* number of states per cell		*/
# define RR		        4  /* length of neighborhood = 2r+1	*/ 
# define DN		        8  /* number of de Bruijn nodes		*/
# define SS     ((RR-1)*(KK-1)+1)  /* distinct sums w/stotalistic rule	*/
# define DS 	      KK*KK*KK*KK  /* number of distinct neighborhoods	*/
# define TS	      RR*(KK-1)+1  /* distinct sums w/totalistic rule	*/
# define BD		       25  /* max number Bernstein coeffs	*/ 

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define K12    (K6*K6)
# define AV	(KK*KK*KK)

# define PDN	     64  	/* nodes in pair diagram = KK^4r	*/
# define SDN	    256  	/* nodes in subset diagram = 2^(KK^2r)	*/
# define XBD	    512		/* max nodes in de Bruijn diagram	*/
# define QDN	   4096		/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	   1024  	/* node list 2-D de Bruijn node & link  */
# define CCY         12		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define RSYM		 4	/* number of rule symmetries = 2*k!	*/
# define WNML	         5	/* arry size to hold hex wolfram number */

# define HH	60		/* points in histogram */

# define NX		       16  /* number of sample rules		*/
# define NY		       16  /* number of REC demonstrations  	*/

# define CLEN		       76  /* rec source program length	 	*/
# define PLEN		   8*CLEN  /* rec object program length	 	*/
# define XLEN		128 	/*buffer length for rec predefined	*/

# define DROWS		20	/* no of rows in demo menu       */
# define DCOLS		36	/* column for second col in d.m. */

# define RROWS		20	/* no of rows in demo menu       */
# define RCOLS		32	/* column for second col in d.m. */

# define HCH   32	/* characters+1 in help menus (text screen)    */
# define GCH   26	/* characters+1 in help menus (graphic screen) */

typedef union birular {
		int one[DS]; 
		int four[KK][KK][KK][KK];
		} birular;
typedef union parneih {
		int one[K3*K3];
		int two[K3][K3];
	 	int six[KK][KK][KK][KK][KK][KK];
		} parneih;
typedef union twoparn {
		int one[K6*K6];
		int two[K6][K6]; 
		int four[K3][K3][K3][K3];
		int twelve[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} twoparn;

/* end lcau2t.h */
