
/* nxprobkt.c						*/
/* program for LCAU2T option 't'			*/
/* calculate probabilities related to evolution		*/
/* generic portion of probkr.c which applies to radius  */
/* 3/2 automata and which do not make explicit use of   */
/* the number of states. It is to be included in each   */
/* specific probks file.				*/
/* Harold V. McIntosh, 20 January 1992			*/

/*  Copyright (C) 1992  */
/*  Harold V. McIntosh  */

/* ---------------------------------------------------- */


void procur(int e, int g);


/* show probability curves */
void procur(e,g) int e, g; {
  switch (e) {
    case 'e': switch (g) {
      case 0: gfram(100,3); gdiag(100,3); break;
      case 1: pdiff(100); break;
      case 2: pdiff3(100); break;
      case 3: pdiff4(100); break;
      case 4: pdiff5(100); break;
//      case 5: pdiff6(100); break;
      default: break;} break;
    case 'i': switch (g) {
      case 0: gfram(100,3); gdiag(100,3); break;
      case 1: pdiff(100); break;
//      case 2: pidiff(100); break;
//      case 3: pjdiff(100); break;
      default: break;} break;
    default: break;}
}

/* show n-block probabilities */
void nblcur(n) int n; {switch (n) {
    case '1': oneblfreq(300,48); break;
    case '2': twoblfreq(300,48); break;
    case '3': thrblfreq(300,48); break;
    case '4': foublfreq(300,48); break;
    case '5': fivblfreq(300,48); break;
    case '6': sixblfreq(300,48); break;
    case '7': svnblfreq(300,48); break;
    default: break;}
}


/* option 'n' (general neighborhood) */
/* empirical distribution of sums within a neighborhood */
/* mm - number of cells	*/
/* nn - number of lines	*/

void gnlsum(mm,nn) int mm, nn; {
int    i0, i1, i2, i3;
int    ii, k, m, n, l, b[KK][KK][KK][KK];
double em, en, f, bf[KK][KK][KK][KK], bft[KK][KK][KK][KK];

asctobin();
em=((double)(mm));
// f=1.0;
f=115.0/((double)(AL));
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++)
	bft[i0][i1][i2][i3]=0.0;
k=0;
for (ii=0; ii<nn; ii++) {
  onegen(mm);
  gnrsum(mm,b);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
	bf[i0][i1][i2][i3]=((double)(b[i0][i1][i2][i3]));
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
	bft[i0][i1][i2][i3]+=bf[i0][i1][i2][i3];
  m=0; videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) {
    n=(int)(f*bf[i0][i1][i2][i3]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i2%2+1);
    }
  videodot(ii,m++,3);
  k++;
  }  /* end for-ii */
  en=((double)(k));
  m=0; videodot(nn,m++,3);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) {
    n=(int)(0.1*(bft[i0][i1][i2][i3]/en));
    if (n>0) for (l=0; l<n; l++) videodot(nn,m++,i0%2+1);
    }
  videodot(nn,m++,3);
}

/* gather totalistic neighborhood sums for one generation */
/* mm = number of cells					  */
/* b[cc]  = sum counts					  */

onesum(mm,cc,b) int mm, cc, *b; {int i, j, k;
  for (i=0; i<cc; i++) b[i]=0;
  k=arr1[mm-1]+arr1[0]+arr1[1]+arr1[2]; b[k]++;
  k=arr1[0]+arr1[1]+arr1[2]+arr1[3]; b[k]++;
  for (i=2; i<mm-2; i++) {k=0; for (j=i-1; j<i+3; j++) k+=arr1[j]; b[k]++;}
  k=arr1[mm-5]+arr1[mm-4]+arr1[mm-3]+arr1[mm-2]; b[k]++;
  k=arr1[mm-4]+arr1[mm-3]+arr1[mm-2]+arr1[mm-1]; b[k]++;
}

/* gather general neighborhood sums for one generation */
/* mm = number of cells             */
/* b[KK][KK][KK][KK]  = sum counts  */
void gnrsum(mm,b) int mm, b[KK][KK][KK][KK]; {int i0, i1, i2, i3, i;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
	b[i0][i1][i2][i3]=0;
  b[arr1[mm-3]][arr1[mm-2]][arr1[mm-1]][arr1[0]]++;
  b[arr1[mm-2]][arr1[mm-1]][arr1[0]][arr1[1]]++;
  b[arr1[mm-1]][arr1[0]][arr1[1]][arr1[2]]++;
  for (i=1; i<mm-2; i++) b[arr1[i-1]][arr1[i]][arr1[i+1]][arr1[i+2]]++;
}

/* Generate coefficients of 2nd generation Bernstein Polynomial */

berncoef(f) double *f; {
int i, i0, i1, i2, i3;

for (i=0; i<BD; i++) bp[i]=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  if (ascrule[i0][i1][i2][i3]=='1') bp[i0+i1+i2+i3]+=1.0;
for (i=0; i<BD; i++) bp[i]*=f[i];
}

/* Generate coefficients of 3rd generation Bernstein Polynomial */

bernthrd() {
int i00, i01, i02, i10, i11, i12, i20, i21, i22;
int i, i0, i1, i2, i3, i4, i5, i6;
int j0, j1, j2, j3;

asctobin();
for (i=0; i<BD; i++) bp[i]=0.0;
switch (dn) {
  case 0: case 1:
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
    for (i6=0; i6<KK; i6++) {
      j0=binrule[i0][i1][i2][i3];
      j1=binrule[i1][i2][i3][i4];
      j2=binrule[i2][i3][i4][i5];
      j3=binrule[i3][i4][i5][i6];
      i=i0+i1+i2+i3+i4+i5+i6;
      if (ascrule[j0][j1][j2][j3]=='1') bp[i]+=1.0;
      }
    break;
  case 2:
    for (i00=0; i00<KK; i00++)
    for (i01=0; i01<KK; i01++)
    for (i02=0; i02<KK; i02++)
    for (i10=0; i10<KK; i10++)
    for (i11=0; i11<KK; i11++)
    for (i12=0; i12<KK; i12++)
    for (i20=0; i20<KK; i20++)
    for (i21=0; i21<KK; i21++)
    for (i22=0; i22<KK; i22++) {
      j0=binrule[i00][i01][i10][i11];
      j1=binrule[i01][i02][i11][i12];
      j2=binrule[i10][i11][i20][i21];
      j3=binrule[i11][i12][i21][i22];
      i=i00+i01+i02+i10+i11+i12+i20+i21+i22;
      if (ascrule[j0][j1][j2][j3]=='1') bp[i]+=1.0;
    }
    break;
  default: break;}
}

/* Generate coefficients of 4th generation Bernstein Polynomial */

bernfrth() {
int i00, i01, i02, i03, i10, i11, i12, i13, i20, i21, i22, i23;
int i30, i31, i32, i33;
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i, i0, i1, i2, i3, i4, i5, i6, i7, i8, i9;
int j0, j1, j2, j3, j4, j5, j6;
int k0, k1, k2, k3;

asctobin();
for (i=0; i<BD; i++) bp[i]=0.0;
switch (dn) {
  case 0: case 1:
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++) {
  j0=binrule[i0][i1][i2][i3];
  j1=binrule[i1][i2][i3][i4];
  j2=binrule[i2][i3][i4][i5];
  j3=binrule[i3][i4][i5][i6];
  j4=binrule[i4][i5][i6][i7];
  j5=binrule[i5][i6][i7][i8];
  j6=binrule[i6][i7][i8][i9];

  k0=binrule[j0][j1][j2][j3];
  k1=binrule[j1][j2][j3][j4];
  k2=binrule[j2][j3][j4][j5];
  k3=binrule[j3][j4][j5][j6];

  i=i0+i1+i2+i3+i4+i5+i6+i7+i8+i9;
  if (ascrule[k0][k1][k2][k3]=='1') bp[i]+=1.0;
  }
    break;
  case 2:
    for (i00=0; i00<KK; i00++)
    for (i01=0; i01<KK; i01++)
    for (i02=0; i02<KK; i02++)
    for (i03=0; i03<KK; i03++)
    for (i10=0; i10<KK; i10++)
    for (i11=0; i11<KK; i11++)
    for (i12=0; i12<KK; i12++)
    for (i13=0; i13<KK; i13++)
    for (i20=0; i20<KK; i20++)
    for (i21=0; i21<KK; i21++)
    for (i22=0; i22<KK; i22++)
    for (i23=0; i23<KK; i23++)
    for (i30=0; i30<KK; i30++)
    for (i31=0; i31<KK; i31++)
    for (i32=0; i32<KK; i32++)
    for (i33=0; i33<KK; i33++) {
      j00=binrule[i00][i01][i10][i11];
      j01=binrule[i01][i02][i11][i12];
      j02=binrule[i02][i03][i12][i13];
      j10=binrule[i10][i11][i20][i21];
      j11=binrule[i11][i12][i21][i22];
      j12=binrule[i12][i13][i22][i23];
      j20=binrule[i20][i21][i30][i31];
      j21=binrule[i21][i22][i31][i32];
      j22=binrule[i22][i23][i32][i33];
  k0=binrule[j00][j01][j10][j11];
  k1=binrule[j01][j02][j11][j12];
  k2=binrule[j10][j11][j20][j21];
  k3=binrule[j11][j12][j21][j22];
    i=i00+i01+i02+i03+i10+i11+i12+i13+
	i20+i21+i22+i23+i30+i31+i32+i33;
    if (ascrule[k0][k1][k2][k3]=='1') bp[i]+=1.0;
      }
    break;
  default: break;}
}

/* Generate coefficients of 5th generation Bernstein Polynomial */

bernfifth() {
int i00, i01, i02, i03, i04, i10, i11, i12, i13, i14;
int i20, i21, i22, i23, i24, i30, i31, i32, i33, i34;
int i40, i41, i42, i43, i44;
int j00, j01, j02, j03, j10, j11, j12, j13;
int j20, j21, j22, j23, j30, j31, j32, j33;
int k00, k01, k02, k10, k11, k12, k20, k21, k22;
int l00, l01, l10, l11;
int i, i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia, ib, ic;
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9;
int k0, k1, k2, k3, k4, k5, k6;
int l0, l1, l2, l3;

asctobin();
for (i=0; i<BD; i++) bp[i]=0.0;
switch (dn) {
  case 0: case 1:
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (ia=0; ia<KK; ia++)
for (ib=0; ib<KK; ib++)
for (ic=0; ic<KK; ic++) {
  j0=binrule[i0][i1][i2][i3];
  j1=binrule[i1][i2][i3][i4];
  j2=binrule[i2][i3][i4][i5];
  j3=binrule[i3][i4][i5][i6];
  j4=binrule[i4][i5][i6][i7];
  j5=binrule[i5][i6][i7][i8];
  j6=binrule[i6][i7][i8][i9];
  j7=binrule[i7][i8][i9][ia];
  j8=binrule[i8][i9][ia][ib];
  j9=binrule[i9][ia][ib][ic];

  k0=binrule[j0][j1][j2][j3];
  k1=binrule[j1][j2][j3][j4];
  k2=binrule[j2][j3][j4][j5];
  k3=binrule[j3][j4][j5][j6];
  k4=binrule[j4][j5][j6][j7];
  k5=binrule[j5][j6][j7][j8];
  k6=binrule[j6][j7][j8][j9];

  l0=binrule[k0][k1][k2][k3];
  l1=binrule[k1][k2][k3][k4];
  l2=binrule[k2][k3][k4][k5];
  l3=binrule[k3][k4][k5][k6];

  i=i0+i1+i2+i3+i4+i5+i6+i7+i8+i9+ia+ib+ic;
  if (ascrule[l0][l1][l2][l3]=='1') bp[i]+=1.0;
  }
    break;
  case 2:
    for (i00=0; i00<KK; i00++)
    for (i01=0; i01<KK; i01++)
    for (i02=0; i02<KK; i02++)
    for (i03=0; i03<KK; i03++)
    for (i04=0; i04<KK; i04++)
    for (i10=0; i10<KK; i10++)
    for (i11=0; i11<KK; i11++)
    for (i12=0; i12<KK; i12++)
    for (i13=0; i13<KK; i13++)
    for (i14=0; i14<KK; i14++)
    for (i20=0; i20<KK; i20++)
    for (i21=0; i21<KK; i21++)
    for (i22=0; i22<KK; i22++)
    for (i23=0; i23<KK; i23++)
    for (i24=0; i24<KK; i24++)
    for (i30=0; i30<KK; i30++)
    for (i31=0; i31<KK; i31++)
    for (i32=0; i32<KK; i32++)
    for (i33=0; i33<KK; i33++)
    for (i34=0; i34<KK; i34++)
    for (i40=0; i40<KK; i40++)
    for (i41=0; i41<KK; i41++)
    for (i42=0; i42<KK; i42++)
    for (i43=0; i43<KK; i43++)
    for (i44=0; i44<KK; i44++) {
      j00=binrule[i00][i01][i10][i11];
      j01=binrule[i01][i02][i11][i12];
      j02=binrule[i02][i03][i12][i13];
      j03=binrule[i03][i04][i13][i14];
      j10=binrule[i10][i11][i20][i21];
      j11=binrule[i11][i12][i21][i22];
      j12=binrule[i12][i13][i22][i23];
      j13=binrule[i13][i14][i23][i24];
      j20=binrule[i20][i21][i30][i31];
      j21=binrule[i21][i22][i31][i32];
      j22=binrule[i22][i23][i32][i33];
      j23=binrule[i23][i24][i33][i34];
      j30=binrule[i30][i31][i40][i41];
      j31=binrule[i31][i32][i41][i42];
      j32=binrule[i32][i33][i42][i43];
      j33=binrule[i33][i34][i43][i44];

      k00=binrule[j00][j01][j10][j11];
      k01=binrule[j01][j02][j11][j12];
      k02=binrule[j02][j03][j12][j13];
      k10=binrule[j10][j11][j20][j21];
      k11=binrule[j11][j12][j21][j22];
      k12=binrule[j12][j13][j22][j23];
      k20=binrule[j20][j21][j30][j31];
      k21=binrule[j21][j22][j31][j32];
      k22=binrule[j22][j23][j32][j33];

  l0=binrule[j00][j01][j10][j11];
  l1=binrule[j01][j02][j11][j12];
  l2=binrule[j10][j11][j20][j21];
  l3=binrule[j11][j12][j21][j22];

    i=i00+i01+i02+i03+i04+i10+i11+i12+i13+i14+
	i20+i21+i22+i23+i24+i30+i31+i32+i33+i34+
	    i40+i41+i42+i43+i44;
    if (ascrule[l0][l1][l2][l3]=='1') bp[i]+=1.0;
      }
    break;
  default: break;}
}

bernsixth() {}

/* graph the frequencies of ascrule in color l	 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */
/* display frequencies in ascrule in color l */

asfreq(l) int l; {
int    i, j, i0, i1, i2, i3;
int    stat[KK], stall, stal, star, starr;	/* statistic counts */
double staf[KK], t, pp;

videoscroll(BROW,0,BROW+8,40,0,0);
videocursor(0,BROW,0);
pp=1.0/((double)(KK*KK*KK*KK));
stall=0; stal=0; star=0; starr=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  j=ascrule[i0][i1][i2][i3]-'0';
  stat[j]++;
  if(j==i0) starr++;
  if(j==i1) star++;
  if(j==i2) stal++;
  if(j==i3) stall++;
  }
videocursor(0,BROW,0);
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) printf("%d freq - %5.2f\n",i,((double)stat[i])*pp);
printf("\n");
printf("lleft  - %5.2f\n",((double)stall)*pp);
printf("left   - %5.2f\n",((double)stal)*pp);
printf("right  - %5.2f\n",((double)star)*pp);
printf("rright - %5.2f\n",((double)starr)*pp);
j=(int)(100.0*staf[1]);
i=(int)(100.0*staf[1]);
if (j>=2) videodot(j-2,i,l);
if (i>=2) videodot(j,i-2,l);
videodot(j,i,1);
if (i<=318) videodot(j,i+2,l);
if (j<=198) videodot(j+2,i,l);
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
videocursor(0,BROW,20);
printf("lambda:   %5.3f",1.0-staf[0]);
videocursor(0,BROW+1,20);
printf("entropy:  %5.3f",-t/log((double)KK));
videocursor(0,BROW,0);
}

/* evaluate the one-block probabilities after one generation */

onebl(x,a) double x[KK], a[KK]; {int i0, i1, i2, i3, j0;

for (j0=0; j0<KK; j0++) x[j0]=0.0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  x[j0]+=a[i0]*a[i1]*a[i2]*a[i3];
  }
}

/* iterate the 1-block parameters to find self-consistent values */
/* graph the iterative steps in bar-chart form			 */
/* mm - length of line	*/
/* nn - number of lines	*/

oneblfreq(mm,nn) int mm, nn; {
int    ii, i, l, m, n;
double op[KK], np[KK];
double d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++) {op[i]=s; for (l=0; l<n; l++) videodot(0,m++,i);}

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  onebl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
    n=(int)(f*np[i]); if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i);
    d=op[i]-np[i];
    e+=d*d;
    op[i]=np[i];
    }
  videodot(ii,m++,3);
  if (op[0]<=0.001) break;
  if (op[1]<=0.001) break;
  if (e<=0.0000001) break;
  }
}

/* evaluate the two-block probabilities after one generation */

twobl(x,a) double x[KK][KK], a[KK][KK]; {
int    i0, i1, i2, i3, i4;
int    j0, j1;
double w, b[KK];

for (j0=0; j0<KK; j0++) {for (j1=0; j1<KK; j1++) x[j0][j1]=0.0;}

for (j0=0; j0<KK; j0++) {b[j0]=0.0; for (j1=0; j1<KK; j1++) b[j0]+=a[j0][j1];}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  j1=ascrule[i1][i2][i3][i4]-'0';
  w=a[i0][i1]*a[i1][i2]*a[i2][i3]*a[i3][i4];
  if (w!=0.0) w/=b[i1]*b[i2]*b[i3];
  x[j0][j1]+=w;
  }
}

/* iterate the 2-block parameters to find self-consistent values */
/* graph the iterative steps in bar-chart form			 */
/* mm - length of line	*/
/* nn - number of lines	*/

twoblfreq(mm,nn) int mm, nn; {
int    ii, i, j, l, m, n;
double op[KK][KK], np[KK][KK];
double d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++)
for (j=0; j<KK; j++) {
  op[i][j]=s;
  for (l=0; l<n; l++) videodot(0,m++,j);
  }
videodot(0,m++,3);

for (i=0; i<KK; i++) {blpr[i]=0.0; for (j=0; j<KK; j++) blpr[i]+=op[i][j];}
videodot((int)(100.0*op[1][1]),(int)(100.0*blpr[1]),1);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  twobl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
  for (j=0; j<KK; j++) {
    n=(int)(f*np[i][j]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,j);
    d=op[i][j]-np[i][j];
    e+=d<0.0?-d:d;
    op[i][j]=np[i][j];
    }}
  videodot(ii,m++,3);
for (i=0; i<KK; i++) {blpr[i]=0.0; for (j=0; j<KK; j++) blpr[i]+=op[i][j];}
videodot((int)(100.0*op[1][1]),(int)(100.0*blpr[1]),2);
  if (e<=0.0001) break;
  }
}

/* evaluate the three-block probabilities after one generation */

thrbl(x,a) double x[KK][KK][KK], a[KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5;
int    j0, j1, j2;
double w, b[KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) x[j0][j1][j2]=0.0;
  b[j0][j1]=0.0;
  for (j2=0; j2<KK; j2++) b[j0][j1]+=a[j0][j1][j2];  
  }}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  j1=ascrule[i1][i2][i3][i4]-'0';
  j2=ascrule[i2][i3][i4][i5]-'0';
  w=a[i0][i1][i2]*a[i1][i2][i3]*a[i2][i3][i4]*a[i3][i4][i5];
  if (w!=0.0) w/=b[i1][i2]*b[i2][i3]*b[i3][i4];
  x[j0][j1][j2]+=w;
  }
}

/* iterate the 3-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

thrblfreq(mm,nn) int mm, nn; {
int    ii, i, j, k, l, m, n;
double op[KK][KK][KK], np[KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
  op[i][j][k]=s;
  for (l=0; l<n; l++) videodot(0,m++,k);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  thrbl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
  for (j=0; j<KK; j++) {
  for (k=0; k<KK; k++) {
    n=(int)(f*np[i][j][k]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,k);
    d=op[i][j][k]-np[i][j][k];
    e+=d<0.0?-d:d;
    op[i][j][k]=np[i][j][k];
    }}}
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }

for (i=0; i<KK; i++) {
  b[i]=0.0;
  for (j=0; j<KK; j++) {
  for (k=0; k<KK; k++) {
    b[i]+=op[i][j][k];
    }} }

for (i=0; i<KK; i++) {
for (j=0; j<KK; j++) {
  bb[i][j]=0.0;
  for (k=0; k<KK; k++) {
    bb[i][j]+=op[i][j][k];
    }} }

}

/* evaluate the four-block probabilities after one generation */

foubl(x,a) double x[KK][KK][KK][KK], a[KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6;
int    j0, j1, j2, j3;
double w, b[KK][KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) x[j0][j1][j2][j3]=0.0;
  b[j0][j1][j2]=0.0;
  for (j3=0; j3<KK; j3++) b[j0][j1][j2]+=a[j0][j1][j2][j3];  
  }}}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  j1=ascrule[i1][i2][i3][i4]-'0';
  j2=ascrule[i2][i3][i4][i5]-'0';
  j3=ascrule[i3][i4][i5][i6]-'0';
  w=a[i0][i1][i2][i3];
  w*=a[i1][i2][i3][i4];
  w*=a[i2][i3][i4][i5];
  w*=a[i3][i4][i5][i6];
  if (w!=0.0) w/=b[i1][i2][i3]*b[i2][i3][i4]*b[i3][i4][i5];
  x[j0][j1][j2][j3]+=w;
  }
}

/* iterate the 4-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

foublfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, l, m, n;
double op[KK][KK][KK][KK], np[KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  op[i0][i1][i2][i3]=s;
  for (l=0; l<n; l++) videodot(0,m++,i3);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  foubl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) {
    n=(int)(f*np[i0][i1][i2][i3]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i3);
    d=op[i0][i1][i2][i3]-np[i0][i1][i2][i3];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3]=np[i0][i1][i2][i3];
    }
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }

for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) {
    b[i0]+=op[i0][i1][i2][i3];
    } }


for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
    bb[i0][i1]+=op[i0][i1][i2][i3];
    }} }}

}

/* evaluate the five-block probabilities after one generation */

fivbl(x,a) double x[KK][KK][KK][KK][KK], a[KK][KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7;
int    j0, j1, j2, j3, j4;
double w, b[KK][KK][KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
for (j2=0; j2<KK; j2++) {
for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) x[j0][j1][j2][j3][j4]=0.0;
  b[j0][j1][j2][j3]=0.0;
  for (j4=0; j4<KK; j4++) b[j0][j1][j2][j3]+=a[j0][j1][j2][j3][j4];  
  }}}}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  j1=ascrule[i1][i2][i3][i4]-'0';
  j2=ascrule[i2][i3][i4][i5]-'0';
  j3=ascrule[i3][i4][i5][i6]-'0';
  j4=ascrule[i4][i5][i6][i7]-'0';
  w=a[i0][i1][i2][i3][i4];
  w*=a[i1][i2][i3][i4][i5];
  w*=a[i2][i3][i4][i5][i6];
  w*=a[i3][i4][i5][i6][i7];
  if (w!=0.0) w/=b[i1][i2][i3][i4]*b[i2][i3][i4][i5]*b[i3][i4][i5][i6];
  x[j0][j1][j2][j3][j4]+=w;
  }
}

/* iterate the 5-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

fivblfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, i4, l, m, n;
double op[KK][KK][KK][KK][KK], np[KK][KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  op[i0][i1][i2][i3][i4]=s;
  for (l=0; l<n; l++) videodot(0,m++,i4);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  fivbl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++) {
  for (i1=0; i1<KK; i1++) {
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
    n=(int)(f*np[i0][i1][i2][i3][i4]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i4);
    d=op[i0][i1][i2][i3][i4]-np[i0][i1][i2][i3][i4];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3][i4]=np[i0][i1][i2][i3][i4];
    }}}}}
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }
for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++) {
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
    b[i0]+=op[i0][i1][i2][i3][i4];
    }}}} }

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
    bb[i0][i1]+=op[i0][i1][i2][i3][i4];
    }} }}}

}

/* evaluate the six-block probabilities after one generation */

sixbl(x,a) double x[KK][KK][KK][KK][KK][KK], a[KK][KK][KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7, i8;
int    j0, j1, j2, j3, j4, j5;
double w, b[KK][KK][KK][KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
for (j2=0; j2<KK; j2++) {
for (j3=0; j3<KK; j3++) {
for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) x[j0][j1][j2][j3][j4][j5]=0.0;
  b[j0][j1][j2][j3][j4]=0.0;
  for (j5=0; j5<KK; j5++) b[j0][j1][j2][j3][j4]+=a[j0][j1][j2][j3][j4][j5];  
  }}}}}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
  j0=ascrule[i0][i1][i2][i3]-'0';
  j1=ascrule[i1][i2][i3][i4]-'0';
  j2=ascrule[i2][i3][i4][i5]-'0';
  j3=ascrule[i3][i4][i5][i6]-'0';
  j4=ascrule[i4][i5][i6][i7]-'0';
  j5=ascrule[i5][i6][i7][i8]-'0';
  w=a[i0][i1][i2][i3][i4][i5];
  w*=a[i1][i2][i3][i4][i5][i6];
  w*=a[i2][i3][i4][i5][i6][i7];
  w*=a[i3][i4][i5][i6][i7][i8];
  if (w!=0.0) w/=b[i1][i2][i3][i4][i5]*b[i2][i3][i4][i5][i6]
	*b[i3][i4][i5][i6][i7];
  x[j0][j1][j2][j3][j4][j5]+=w;
  }
}

/* iterate the 6-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

sixblfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, i4, i5, l, m, n;
double op[KK][KK][KK][KK][KK][KK];
double np[KK][KK][KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  op[i0][i1][i2][i3][i4][i5]=s;
  for (l=0; l<n; l++) videodot(0,m++,i5);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  sixbl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++) {
  for (i1=0; i1<KK; i1++) {
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
  for (i5=0; i5<KK; i5++) {
    n=(int)(f*np[i0][i1][i2][i3][i4][i5]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i5);
    d=op[i0][i1][i2][i3][i4][i5]-np[i0][i1][i2][i3][i4][i5];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3][i4][i5]=np[i0][i1][i2][i3][i4][i5];
    }}}}}}
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }
for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    b[i0]+=op[i0][i1][i2][i3][i4][i5];
    }

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
  for (i5=0; i5<KK; i5++) {
    bb[i0][i1]+=op[i0][i1][i2][i3][i4][i5];
    }} }}}}

}

svnblfreq(mm,nn) int mm, nn; {}

/* end nxprobks.c */
