
/* ruin2h.c						*/
/* program for qhil option 'd'				*/
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen	*/
/* Harold V. McIntosh, 20 February 1988			*/
/* 21 February 1988 - add j0=i0; to Pass 4's [HVM]	*/
/* 12 August 1988 - adaptation for squl.c [HVM]		*/
/* 24 October 1989 - adaptation for r = 1/2		*/
/* 20 November 1989 - removed loop in kwait		*/

# include <qhil.h>

# define PM	2  /* cells in 1-g partial neighborhood	*/
# define QM	2  /* cells in 1-g fringe neighborhood	*/
# define PN	6  /* cells in 2-g partial neighborhood	*/
# define QN	3  /* cells in 2-g fringe neighborhood	*/
# define NW    25  /* pause after so many lines		*/

extern int  aa[NN][NN];
extern int  bb[KK][KK][KK][KK];
extern int  cc[KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern int  binrule[KK][KK][KK][KK];
extern int  arr1[AL][AL];		/* planar array */
extern int  arr2[AL][AL];		/* planar array */

int  mc, nc, nl;			/* column & line control   */

/* edit the de Bruijn diagram */

edijn1() {
char c;

clijn();
while (0<1) {
  rmenu();
  scrrul(UROW,UCOL);
  videocursor(0,0,0); videoputc('d',1);
  videocursor(0,0,1); videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,2); videoputc(c,2);
  videocursor(0,0,1); videoputc(' ',2);
  videocursor(0,5,0);
  switch (c) {

    case 'a': scrstr("upper left:  "); apass1(0); break;
    case 'b': scrstr("upper right: "); apass1(1); break;
    case 'c': scrstr("lower left:  "); apass1(2); break;
    case 'd': scrstr("lower right: "); apass1(3); break;
    case 'e': scrstr("zeroes:      "); apass1(4); break;
    case 'f': scrstr("ones:        "); apass1(5); break;

    case 'A': apass7(1,1); break;
    case 'B': apass7(2,1); break;
    case 'C': apass7(3,1); break;
    case 'D': apass7(4,1); break;
    case 'E': apass7(5,1); break;
    case 'F': apass7(6,1); break;
    case 'M': apass7(1,0); break;
    case 'N': apass7(2,0); break;
    case 'O': apass7(3,0); break;
    case 'P': apass7(4,0); break;
    case 'Q': apass7(5,0); break;
    case 'R': apass7(6,0); break;
    case 'S': apass7(7,0); break;
    case 'T': apass7(8,0); break;

    case '!': afilp(aa,1); break;
    case '@': afilp(aa,2); break;
    case '#': afilp(aa,3); break;
    case '$': afilp(aa,4); break;
    case '%': afilp(aa,5); break;
    case '^': afilp(aa,6); break;

    case 'g': onegen(arr1,arr2); screen(arr1); break;
    case 'X': aprnz(bb); aprnd(bb); break;
    case 'x': aaprnz(aa); break;
    case 't': astrp(bb,bb); break;

    case '=': videocursor(0,6,0); apass4(bb); break;
    case '8': aeipo(bb); break;

    case 'z': clmat(); break;
    case 'Z': videoscroll(0,0,24,39,0,0); break;
    case '?': case '/': clijn(); break;
    default: break;
    }	/* end switch */
  }	/* end while  */
videocursor(0,0,1); videoputc(' ',2);
videocursor(0,0,2); videoputc(' ',2);
videoscroll(1,0,24,39,0,0);
}	/* end edijn1 */

/* clear space for the matrix */
clmat() {videoscroll(6,0,24,24,0,0);}

/* clear edijn screen and set up menu */

clijn() {
videoscroll(6,25,24,39,0,0);
  videocursor(0,7,27);  scrstr("abcdef-shifts");
  videocursor(0,8,27);  scrstr("ABCDEF-strips");
  videocursor(0,9,27);  scrstr("MNOPQRS-0,0's");
  videocursor(0,10,27); scrstr("=-type matrix");
  videocursor(0,11,27); scrstr("g-matrix grid");
  videocursor(0,12,27); scrstr("m-grph matrix");
  videocursor(0,13,27); scrstr("t-mtrx power");
  videocursor(0,14,27); scrstr("8-survey 1-9");
  videocursor(0,15,27); scrstr("/,z-clr scrn");
  videocursor(0,16,27); scrstr("Z-clear all");
  videocursor(0,17,27); scrstr("<cr> - exit");
}

edijn2() {
char c;

  clijn();
  while (0<1) {
  rmenu();
  scrrul(UROW,UCOL);
  videocursor(0,0,0); videoputc('d',1);
  videocursor(0,0,1); videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,2); videoputc(c,2);
  videocursor(0,0,1); videoputc(' ',2);
  videocursor(0,5,0);
  switch (c) {

    case 'a': scrstr("northwest    "); pass1(0); break;
    case 'b': scrstr("north        "); pass1(1); break;
    case 'c': scrstr("northeast    "); pass1(2); break;
    case 'd': scrstr("west         "); pass1(3); break;
    case 'e': scrstr("stationary   "); pass1(4); break;
    case 'f': scrstr("east         "); pass1(5); break;
    case 'g': scrstr("southwest    "); pass1(6); break;
    case 'h': scrstr("south        "); pass1(7); break;
    case 'i': scrstr("southeast    "); pass1(8); break;
    case 'j': scrstr("super nw     "); pass1(9); break;
    case 'k': scrstr("super ne     "); pass1(10); break;
    case 'l': scrstr("super sw     "); pass1(11); break;
    case 'm': scrstr("super se     "); pass1(12); break;
    case 'n': scrstr("zeroes       "); pass1(13); break;
    case 'o': scrstr("ones         "); pass1(14); break;

    case 'A': pass7(1,1); break;
    case 'B': pass7(2,1); break;
    case 'C': pass7(3,1); break;
    case 'D': pass7(4,1); break;
    case 'E': pass7(5,1); break;
    case 'F': pass7(6,1); break;
    case 'M': pass7(1,0); break;
    case 'N': pass7(2,0); break;
    case 'O': pass7(3,0); break;
    case 'P': pass7(4,0); break;
    case 'Q': pass7(5,0); break;
    case 'R': pass7(6,0); break;
    case 'S': pass7(7,0); break;
    case 'T': pass7(8,0); break;

    case '!': filp(aa,1); break;
    case '@': filp(aa,2); break;
    case '#': filp(aa,3); break;
    case '$': filp(aa,4); break;
    case '%': filp(aa,5); break;
    case '^': filp(aa,6); break;

    case 'p': prng(1); break;
    case 't': strp(aa,aa); break;
    case '=': videocursor(0,6,0); pass4(cc); break;
    case '8': eipo(cc); break;
    case 'r': onegen(arr1,arr2); screen(arr1); break;
    case 'x': prnz(aa); break;
    case 'z': clmat(); break;
    case 'Z': videoscroll(0,0,24,39,0,0); break;
    case '?': case '/': clijn(); break;
    default: break;
    }	/* end switch */
  }	/* end while  */
videocursor(0,0,1); videoputc(' ',2);
videocursor(0,0,2); videoputc(' ',2);
videoscroll(1,0,24,39,0,0);
}	/* end edijn2 */

/* pause at the end of a full screen	    */
/* kwait(0) - short or null line	    */
/* kwait(1) - split long lines as necessary */
/* kwait(2) - wait to continue		    */
/* kwait(3) - reset 			    */

kwait(i) int i; {
switch (i) {
  case 0: printf("\n"); nc=0; nl++; break;
  case 1: if (nc==mc) {printf("&\n"); nc=1; nl++;} else nc++; break;
  case 2: nl=NW; break;
  case 3: nc=0; nl=0; break;
  default: break;}
if (nl==NW) {
  nl=1;
  printf(" press any key to continue\015");
  kbdin();
  printf("                          \015");
  videoscroll(0,0,24,39,0,0);
  videocursor(0,0,0);
  }
}

/* ONE31.C */

/* Pass 1 marks sequences conforming to some shift */

apass1(l) int l; {
int  i0, i1, i2, i3;
int  k, m;
asctobin();
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
  k=binrule[i0][i1][i2][i3];
  switch (l) {
    case 0: m=i0; break;
    case 1: m=i1; break;
    case 2: m=i2; break;
    case 3: m=i3; break;
    case 4: m=0;  break;
    case 5: m=1;  break;
    default: break;}
  bb[i0][i1][i2][i3]=k==m?1:0;
  aadot(i2*KK+i3,i0*KK+i1,k==m?1:2);
  }}}}
}

/* pass 4 - print the matrix elements of the connection matrix */

apass4(z) int z[KK][KK][KK][KK]; {
int  i0, i1, i2, i3;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  if (z[i0][i1][i2][i3]!=0) 
     printf("%1d%1d, ",i0*KK+i1,i2*KK+i3);
  }}
  printf("\n");
  }}
}

/* apass7 - get the loops of length l			*/
/* t = 0: loops through (0,0), t = 1: all loops		*/
/* oc is used to mark links while locating pure loops.	*/
/* 4 indicates a viable link, add 1 for in link, 2 for	*/
/* out link. Thus links marked 7 survive until the next	*/
/* round, then get marked 4, all else 0. Repeat until	*/
/* no 5's or 6's show.					*/
/* the apass7 nest uses the global variables aa[NN][NN]	*/
/* and bb[KK][KK][KK][KK].				*/ 

apass7(l,t) int l, t; {
int  f, g, k, p, q, no, lk, tc[MM];
if (l>XC) return;
videoscroll(7,24,24,39,0,0);
videocursor(0,5,14); printf("width %1d.",l);
videocursor(0,7,25); printf("gen nodes links");
for (p=0; p<MM; p++) tc[p]=4;
k=0;
do {
  g=0; k++; no=0; lk=0;
  videoscroll(6,7,24,24,0,0);
  apass7x(tc,&lk,l,0,t);
  for (p=0; p<MM; p++) {
    f=tc[p];
    if (f==7) no++;
    if (f==5||f==6) g=1;
    tc[p]=f==7?4:0;
    }
  videocursor(0,8+k%16,25); printf("%3d %5d %5d",k,no,lk);
  } while (g==1);
videocursor(0,24,0);
/* kwait(2);
/* apass7x(tc,&lk,l,3,t);
/* kwait(2);
*/
if (l<=XC) {
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) aa[p][q]=-1;
  apass7x(tc,&lk,l,4,t);
  return;
  }
if (l<XC+2) {
  g=4;
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) aa[p][q]=(aa[p][q]==4)?g++:0;
  videoscroll(6,7,24,24,0,0);
  apass7x(tc,&lk,l,2,t);
  return;
  }
}

/* apass 7x - display the acceptable strings of length l */
/* s = 0,1,2,3 display mode; t = 0,1 (0,0) vs general	*/

apass7x(tc,lk,l,s,t)  int *tc, *lk; int l, s, t; {
int i[PM], j[PM], r[QM][10];
int p;
if (l<1) return;
switch (t) {
  case 0:
    if (l>XC+2) return;			/* string length up to 7 */
    for (p=0; p<PM; p++) i[p]=j[p]=0;
    apass7a(tc,lk,r,i,j,0,l,s);
    break;
  case 1:
    if (l>XC) return;			/* general strings take more space */
    for (i[0]=0; i[0]<KK; i[0]++) {
    for (i[1]=0; i[1]<KK; i[1]++) {
      for (p=0; p<PM; p++) j[p]=i[p];
      apass7a(tc,lk,r,i,j,0,l,s);
      }}
    break;
  default: break;
  }
}

/* apass 7a - recursive step in pass 7 */

apass7a(tc,lk,r,i,j,k,l,s)
int  tc[MM], *lk;
int  *i, *j, k, l, s;
int  r[QM][10];
{
int p, w, x, i0, i1, j0, j1;
if (k<l) {
  j0=j[0]; j1=j[1];
  for (i0=0; i0<KK; i0++) {r[0][k]=i0;
  for (i1=0; i1<KK; i1++) {r[1][k]=i1;
    if (bb[j0][j1][i0][i1]) {
      j[0]=i0; j[1]=i1;
      apass7a(tc,lk,r,i,j,k+1,l,s);}
    }}
  return;}
for (p=0; p<PM; p++) if (i[p]!=j[p]) return;
for (p=0, w=0; p<l; p++) w=w*KK+r[0][p];
for (p=0, x=0; p<l; p++) x=x*KK+r[1][p];
if ((tc[w]>=4)&&(tc[x]>=4)) {
  switch (s) {
    case 0: /* record in's and out's */
      jdot(2*w,2*x,1); jdot(2*w+1,2*x+1,1); tc[w]|=1;
      jdot(2*w+1,2*x,2); jdot(2*w,2*x+1,2); tc[x]|=2;
      (*lk)++; break;
    case 1: /* graph and linkage matrix - full numbering */
      jdot(2*w,2*x,3); jdot(2*w+1,2*x+1,3);
      jdot(2*w+1,2*x,3); jdot(2*w,2*x+1,3);
      break;
    case 2: /* graph w/o linkage matrix */
      jdot(w,x,3);
      break;
    case 3: /* print links on screen */
      printf("      ");
      if (l>1) for (p=0; p<l-1; p+=2)
        printf("%1.1X",((r[0][p]*KK+r[1][p])*KK+r[0][p+1])*KK+r[1][p+1]);
      if (l%2==1) printf("%1.1X",r[0][l-1]*KK+r[1][l-1]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[0][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[1][p]); kwait(0);
      break;
    case 4: /* fill out aa[w][x] */
      aa[w][x]=4;
      break;
    default: break;
  }} 
}

/* calculate the trace of 2x2 z */
long int atraz(z) int z[KK][KK][KK][KK]; {
int i0, i1;
long int k;
k=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  k+=z[i0][i1][i0][i1];
return k;
}

/* print the diagonal of the 2x2 array z */
aprnd(z) int z[KK][KK][KK][KK]; {
int i, j, k, l, i0, i1;
l=0;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
    i=i0+i1*KK;
    k=z[i0][i1][i0][i1];
    l+=k;
    j=k==0?1:3;
    aadot(i,i,j);
  }}
  videocursor(0,1,10); printf("%8u",z[0][0][0][0]);
  videocursor(0,1,20); printf("%8u",l);
}

/* show the outline of the 2x2 array z as dots on the videoscreen */
/* that is, set up a grid with double spaced dots of color l	  */
aprng(l) int l;{
int i0, i1;
int j0, j1;
int i, j;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
    i=j0+j1*KK;
    j=i0+i1*KK;
    jdot(2*i,2*j,l);
    }}
  }}
}

/* show the NXN array z as a set of dots on the videoscreen */
aprnz(z) int z[NN][NN]; {int i0, i1;
for (i0=0; i0<NN; i0++) for (i1=0; i1<NN; i1++)
  if (z[i0][i1]==-1) bbdot(i0,i1,1); else aadot(i0,i1,3);}

/* show the 2x2 array z as a set of dots on the videoscreen */
aaprnz(z) int z[KK][KK][KK][KK]; {
int i0, i1;
int j0, j1;
int i, j, k;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
    i=j0+KK*j1;
    j=i0+KK*i1;
    k=z[i0][i1][j0][j1];
    if (k==0) bbdot(i,j,1); else aadot(i,j,3);
    }}
  }}
}

/* number of cycles for six widths of 2x2 */
astrp(bb) int *bb; {int x[KK][KK][KK][KK];
amcopy(x,bb);
amprod(x,x,bb);
aprnz(x);
aprnd(x);
}

/* calculate traces and (0,0) elements for first 9 powers of bb */
aeipo(bb) int  bb[KK][KK][KK][KK]; {
int  i, x[KK][KK][KK][KK];
long int atraz();
videoscroll(7,25,24,39,0,0);
videocursor(0,7,25);
printf("%6u",bb[0][0][0][0]);
printf(",%8lu",atraz(bb));
amcopy(x,bb);
for (i=0; i<8; i++) {
  amprod(x,x,bb);
  videocursor(0,8+i,25);
  printf("%6u",x[0][0][0][0]);
  printf(",%8lu",atraz(x));
  }
}

/* plot a big square to represent a matrix element */
aadot(i,j,l) int i, j, l; {
jdot(2*i,2*j,l);
jdot(2*i+1,2*j,l);
jdot(2*i,2*j+1,l);
jdot(2*i+1,2*j+1,l);
}

/* plot a faint square to represent a matrix element */
bbdot(i,j,l) int i, j, l; {
jdot(2*i,2*j,0);
jdot(2*i+1,2*j,0);
jdot(2*i,2*j+1,0);
jdot(2*i+1,2*j+1,l);
}

/* multiply two 2x2 matrices */
amprod(z,x,y)
int x[KK][KK][KK][KK];
int y[KK][KK][KK][KK];
int z[KK][KK][KK][KK];
{
int i0, i1;
int j0, j1;
int k0, k1;

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {

for (k0=0; k0<KK; k0++) {
for (k1=0; k1<KK; k1++) {

  z[i0][i1][k0][k1]=0; 

  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {

    z[i0][i1][k0][k1]+= 
    x[i0][i1][j0][j1]*
    y[j0][j1][k0][k1];

      }}}}}}
}

/* copy one 2x2 array to another */
amcopy(z,x)
int z[KK][KK][KK][KK];
int x[KK][KK][KK][KK];
{
int i0, i1;
int j0, j1;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)

    z[i0][i1][j0][j1]=x[i0][i1][j0][j1];

}

/* THREE31.C */

/* Pass 1 marks sequences conforming to some shift */

pass1(l) int l; {
int  i0, i1, i2, i3, i4, i5, i6, i7, i8;
int  j0, j1, j2, j3;
int  k, m;
asctobin();
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
  j0=binrule[i0][i1][i3][i4];
  j1=binrule[i1][i2][i4][i5];
  j2=binrule[i3][i4][i6][i7];
  j3=binrule[i4][i5][i7][i8];
  k=binrule[j0][j1][j2][j3];
  switch (l) {
    case 0: m=i0; break;
    case 1: m=i1; break;
    case 2: m=i2; break;
    case 3: m=i3; break;
    case 4: m=i4; break;
    case 5: m=i5; break;
    case 6: m=i6; break;
    case 7: m=i7; break;
    case 8: m=i8; break;
    case 9: m=j0; break;
    case 10: m=j1; break;
    case 11: m=j2; break;
    case 12: m=j3; break;
    case 13: m=0;  break;
    case 14: m=1;  break;
    default: break;}
  cc[i0][i1][i2][i3][i4][i5][i6][i7][i8]=k==m?1:0;
  jdot(bdex(i3,i4,i5,i6,i7,i8),bdex(i0,i1,i2,i3,i4,i5),k==m?1:2);
  }}}}}}}}} 
}

/* turn binary index into a coordinate */
int bdex(i0,i1,i2,i3,i4,i5) int i0, i1, i2, i3, i4, i5; {
return i5+KK*(i4+KK*(i3+KK*(i2+KK*(i1+KK*i0))));
}

/* turn three binary digits into a decimal number */
int tdex(i0,i1,i2) int i0, i1, i2; {return i2+KK*(i1+KK*i0);}

/* pass 4 - print the matrix elements of the connection matrix */
pass4(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int  i0, i1, i2, i3, i4, i5, i6, i7, i8;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  for (i6=0; i6<KK; i6++)
  for (i7=0; i7<KK; i7++)
  for (i8=0; i8<KK; i8++)
  if (z[i0][i1][i2][i3][i4][i5][i6][i7][i8]) 
     printf("%1d%1d%1d, ",tdex(i0,i1,i2),tdex(i3,i4,i5),tdex(i6,i7,i8));
  printf("\n");}
}

/* pass7 - get the loops of length l */
/* oc is used to mark links while locating pure loops.	*/
/* 4 indicates a viable link, add 1 for in link, 2 for	*/
/* out link. Thus links marked 7 survive until the next	*/
/* round, mark them 4, all else 0; then repeat until no	*/
/* 5's or 6's show.					*/
/* the pass7 nest uses the global variables aa[NN][NN]	*/
/* and cc[KK][KK][KK][KK][KK][KK][KK][KK][KK].		*/ 

pass7(l,t) int l, t; {
int  f, g, k, p, q, no, lk, tc[MM][MM];
if (l>XC) return;
videoscroll(7,24,24,39,0,0);
videocursor(0,5,14); printf("width %1d.",l);
videocursor(0,7,25); printf("gen nodes links");
for (p=0; p<MM; p++) for (q=0; q<MM; q++) tc[p][q]=4;
k=0;
do {
  g=0; k++; no=0; lk=0;
  videoscroll(6,7,24,24,0,0);
  pass7x(tc,&lk,l,0,t);
  for (p=0; p<MM; p++) for (q=0; q<MM; q++) {
    f=tc[p][q];
    if (f==7) no++;
    if (f==5||f==6) g=1;
    tc[p][q]=f==7?4:0;
    }
    videocursor(0,8+k%16,25); printf("%3d %5d %5d",k,no,lk);
  } while (g==1);
videocursor(0,24,0);
/* kwait(2);
/* pass7x(tc,&lk,l,3,t);
/* kwait(2);
*/

if (l<=XC) {
  g=4;
  for (p=0; p<MM; p++) for (q=0; q<MM; q++) {
    if (g>NN+4) break;
    if (tc[p][q]==0) continue;
    tc[p][q]=g; g++;
    }
  if (g>NN+4) return;
  videoscroll(6,7,24,24,0,0);
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) aa[p][q]=-1;
  pass7x(tc,&lk,l,4,t);
  return;
  }
if (l<=XC+2) {
  g=4;
  for (p=0; p<MM; p++) for (q=0; q<MM; q++) tc[p][q]=(tc[p][q]==4)?g++:0;
  videoscroll(6,7,24,24,0,0);
  pass7x(tc,&lk,l,2,t);
  return;
  }
}

/* pass 7x - display the acceptable strings of length l */
pass7x(tc,lk,l,s,t) int *tc, *lk, l, s, t; {
int i[PN], j[PN], r[QN][10];
int p;
if (l<1) return;
switch (t) {
  case 0:
    if (l>XC+2) return;
    for (p=0; p<PN; p++) i[p]=0;
    for (p=0; p<PN; p++) j[p]=0;
    pass7a(tc,lk,r,i,j,0,l,s);
    break;
  case 1:
    if (l>XC) return;
    for (i[0]=0; i[0]<KK; i[0]++) {
    for (i[1]=0; i[1]<KK; i[1]++) {
    for (i[2]=0; i[2]<KK; i[2]++) {
    for (i[3]=0; i[3]<KK; i[3]++) {
    for (i[4]=0; i[4]<KK; i[4]++) {
    for (i[5]=0; i[5]<KK; i[5]++) {
      for (p=0; p<PN; p++) j[p]=i[p];
      pass7a(tc,lk,r,i,j,0,l,s);
      }}}}}}
    break;
  default: break;
  }
}

/* pass 7a - recursive step in pass 7 */
pass7a(tc,lk,r,i,j,k,l,s)
int  *i, *j, *lk, k, l, s;
int  r[QN][10];
int  tc[MM][MM];
{
int p, w, x, y, i0, i1, i2;
int jj0, jj1, jj2, jj3, jj4, jj5;
int p5;
int q5;
if (k<l) {
  jj0=j[0]; jj1=j[1]; jj2=j[2]; jj3=j[3]; jj4=j[4]; jj5=j[5];
  for (i0=0; i0<KK; i0++) {r[0][k]=i0;
  for (i1=0; i1<KK; i1++) {r[1][k]=i1;
  for (i2=0; i2<KK; i2++) {r[2][k]=i2;
    if (cc[jj0][jj1][jj2][jj3][jj4][jj5][i0][i1][i2]) {
      j[0]=jj3; j[1]=jj4; j[2]=jj5; j[3]=i0; j[4]=i1; j[5]=i2;
      pass7a(tc,lk,r,i,j,k+1,l,s);}
    }}}
  return;}
for (p=0; p<PN; p++) if (i[p]!=j[p]) return;
for (p=0, w=0; p<l; p++) w=w*KK+r[0][p];
for (p=0, x=0; p<l; p++) x=x*KK+r[1][p];
for (p=0, y=0; p<l; p++) y=y*KK+r[2][p];
if ((tc[w][x]>=4)&&(tc[x][y]>=4)) {
  switch (s) {
    case 0:
      jdot(2*w,2*x,1); jdot(2*w+1,2*x+1,1); tc[w][x]|=1;
      jdot(2*x+1,2*y,2); jdot(2*x,2*y+1,2); tc[x][y]|=2;
      (*lk)++; break;
    case 1: /* graph and linkage matrix - full numbering */
      p5=aa[w][x]-4;
      q5=aa[x][y]-4;
      jdot(2*p5,2*q5,3); jdot(2*p5+1,2*q5+1,3);
      jdot(2*p5+1,2*q5,3); jdot(2*p5,2*q5+1,3);
      break;
    case 2:
      p5=aa[w][x]-4;
      q5=aa[x][y]-4;
      jdot(p5,q5,3);
      break;
    case 3:
      printf("      ");
      if (l>1) for (p=0; p<l-1; p+=2)
        printf("%1.1X",((r[0][p]*KK+r[1][p])*KK+r[0][p+1])*KK+r[1][p+1]);
      if (l%2==1) printf("%1.1X",r[0][l-1]*KK+r[1][l-1]); printf(" ");
      if (l>1) for (p=0; p<l-1; p+=2)
	printf("%1.1X",((r[1][p]*KK+r[2][p])*KK+r[1][p+1])*KK+r[2][p+1]);
      if (l%2==1) printf("%1.1X",r[1][l-1]*KK+r[2][l-1]); printf(" - ");
      for (p=0; p<l; p++) printf("%1.1d",r[0][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[1][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[2][p]); kwait(0);
      break;
    case 4:
      p5=tc[w][x]-4; q5=tc[x][y]-4;
      aa[p5][q5]=x;
      jdot(2*p5,2*q5,3); jdot(2*p5+1,2*q5+1,3);
      jdot(2*p5+1,2*q5,3); jdot(2*p5,2*q5+1,3);
      break;
    default: break;
  }} 
}

/* number of cycles for six widths of 6x6 */
strp(aa,cc) char *aa, *cc; {
char  x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
mcopy(x,cc);
mprod(cc,aa,x);
prnz(cc);
/*prnd(cc);*/
}

/* calculate traces and (0,0) elements for first 9 powers of x */
eipo(x) char x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
char     y[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int      i;
long int traz();
videoscroll(7,25,24,39,0,0);
videocursor(0,7,25);
printf("%6u",x[0][0][0][0][0][0][0][0][0][0][0][0]);
printf(",%8lu",traz(x));
mcopy(y,x);
for (i=0; i<8; i++) {
  mprod(y,y,x);
  videocursor(0,8+i,25);
  printf("%6u",y[0][0][0][0][0][0][0][0][0][0][0][0]);
  printf(",%8lu",traz(y));
  }
}

/* fill a 6x6 array with zeroes */
zerar(z)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=0;

}

/* copy one 6x6 array to another */
mcopy(z,x)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=
    x[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];

}

/* multiply two matrices */
mprod(z,x,y)
int x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int y[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int k0, k1, k2, k3, k4, k5;

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {

for (k0=0; k0<KK; k0++) {
for (k1=0; k1<KK; k1++) {
for (k2=0; k2<KK; k2++) {
for (k3=0; k3<KK; k3++) {
for (k4=0; k4<KK; k4++) {
for (k5=0; k5<KK; k5++) {

  z[i0][i1][i2][i3][i4][i5][k0][k1][k2][k3][k4][k5]=0; 

  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) {

    z[i0][i1][i2][i3][i4][i5][k0][k1][k2][k3][k4][k5]+= 
    x[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]*
    y[j0][j1][j2][j3][j4][j5][k0][k1][k2][k3][k4][k5];

      }}}}}}}}}}}}}}}}}}
}

/* show the outline of the array z as dots on the videoscreen */
prng(l) int l;{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int i, j;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) {
    i=bdex(j0,j1,j2,j3,j4,j5);
    j=bdex(i0,i1,i2,i3,i4,i5);
    jdot(2*i,2*j,l);
    }}}}}}
  }}}}}}
}

/* calculate the trace of 6x6 z */
long int traz(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
long int k;
k=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  k+=z[i0][i1][i2][i3][i4][i5][i0][i1][i2][i3][i4][i5];
return k;
}

/* show the NXN array z as a set of dots on the videoscreen */
prnz(z) int z[MM][MM]; {int i0, i1;
for (i0=0; i0<MM; i0++) for (i1=0; i1<MM; i1++)
  if (z[i0][i1]==-1) bbdot(i0,i1,1); else aadot(i0,i1,3);}

/* fill the field with a configuration of periodicity obtained	*/
/* with the help of a de Bruijn diagram.			*/

afilp(oc,l) int *oc; int l; {
int x[NN*NN], y[NN], z[XC], i0, j0, i, j, k, n;
lnze(x,&n,oc);
videocursor(0,0,34); printf("%5d",n);
k=0; if (n>0) k=rand()%n;
i0=x[k]/NN; j0=x[k]%NN;
ecox(z,i0,l); for (k=0; k<AL; k++) arr1[k][AL/2]=z[k%l];
ecox(z,j0,l); for (k=0; k<AL; k++) arr1[k][AL/2+1]=z[k%l];
i=j0;
for (j=AL/2+2; j<AL; j++) {
  lnzr(y,&n,oc,i);
  videocursor(0,0,28); printf("%5d",n);
  i=0; if (n>0) i=rand()%n; i=y[i];
  ecox(z,i,l); for (k=0; k<AL; k++) arr1[k][j]=z[k%l];
  }
i=i0;
for (j=AL/2-1; j>=0; j--) {
  lnzc(y,&n,oc,i);
  videocursor(0,0,28); printf("%5d",n);
  i=0; if (n>0) i=rand()%n; i=y[i];
  ecox(z,i,l); for (k=0; k<AL; k++) arr1[k][j]=z[k%l];
  }
screen(arr1);
}

/* fill the field with a configuration of periodicity obtained	*/
/* with the help of a de Bruijn diagram.			*/

filp(oc,l) int oc[NN][NN], l; {
int x[NN*NN], y[NN], z[XC], i0, i1, i, j, k, n;
lnze(x,&n,oc);
videocursor(0,0,34); printf("%5d",n);
if (n==0) return;
k=rand()%n;
i0=x[k]/NN; i1=x[k]%NN;
ecox(z,oc[i0][i1],l); for (k=0; k<AL; k++) arr1[k][AL/2]=z[k%l];
for (j=AL/2+1; j<AL; j++) {
  lnzr(y,&n,oc,i1);
  videocursor(0,0,28); printf("%5d",n);
  i=0; if (n>0) i=rand()%n; i=y[i];
  ecox(z,oc[i1][i],l); for (k=0; k<AL; k++) arr1[k][j]=z[k%l];
  i1=i;}
for (j=AL/2-1; j>=0; j--) {
  lnzc(y,&n,oc,i0);
  videocursor(0,0,28); printf("%5d",n);
  i=0; if (n>0) i=rand()%n; i=y[i];
  ecox(z,oc[i][i0],l); for (k=0; k<AL; k++) arr1[k][j]=z[k%l];
  i0=i;}
screen(arr1);
}

/* locate and count the nonzero elements of the rth row of oc */
lnzr(x,n,oc,r)  int oc[NN][NN]; int x[NN], *n, r; {int i, m;
for (i=0, m=0; i<NN; i++) if (oc[r][i]!=-1) {x[m]=i; m++;} 
*n=m;}
			
/* locate and count the nonzero elements of a column of oc */
lnzc(x,n,oc,c)  int oc[NN][NN]; int x[NN], *n, c; {int i, m;
for (i=0, m=0; i<NN; i++) if (oc[i][c]!=-1) {x[m]=i; m++;}
*n=m;}

/* locate and count the nonzero elements within the matrix oc */
lnze(x,n,oc)  int oc[NN][NN]; int x[NN*NN], *n; {int i, j, m;
m=0; for (i=0; i<NN; i++) for (j=0; j<NN; j++) 
  if (oc[i][j]!=-1) {x[m]=i*NN+j; m++;}
*n=m;}

/* decompose an index n into a series of l cell values */
ecox(x,n,l) int x[XC], n, l; {int i;
for (i=0; i<l; i++, n/=KK) x[l-1-i]=n%KK;
}

/* end */
