
/* ruin2h.c						*/
/* program for qhil option 'd'				*/
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen	*/
/* Harold V. McIntosh, 20 February 1988			*/
/* 21 February 1988 - add j0=i0; to Pass 4's [HVM]	*/
/* 12 August 1988 - adaptation for squl.c [HVM]		*/
/* 24 October 1989 - adaptation for r = 1/2		*/

# include <qhil.h>

# define JX   0.8  /* x-center, de Bruijn diagram	*/
# define JY   0.5  /* y-center, de Bruijn diagram	*/
# define RI 0.455  /* inner radius, de Bruijn diagram	*/
# define RO 0.475  /* outer radius, de Bruijn diagram	*/
# define PM	2  /* cells in 1-g partial neighborhood	*/
# define QM	2  /* cells in 1-g fringe neighborhood	*/
# define PN	6  /* cells in 2-g partial neighborhood	*/
# define QN	3  /* cells in 2-g fringe neighborhood	*/
# define XC	6  /* maximum cycle length		*/
# define NN    64  /* node count = KK^(mx cycle length)	*/
# define NW    25  /* pause after so many lines		*/

char   aa[NN][NN];
extern int  binrule[KK][KK][KK][KK];
extern int  arr1[AL][AL];	/* planar array */
extern int  ix0, iy0;		/* origin for pen movement */

int  mc, nc, nl;	/* column & line control	*/
int  no, lk;		/* # nodes, links 		*/

/* edit the de Bruijn diagram */

edijn() {
char c;
int  cc[KK][KK][KK][KK];

  clijn();
  while (0<1) {
  rmenu();
  scrrul(UROW,UCOL);
  videocursor(0,0,0); videoputc('d',1);
  videocursor(0,0,1); videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,2); videoputc(c,2);
  videocursor(0,0,1); videoputc(' ',2);
  videocursor(0,5,0);
  switch (c) {

    case '2':
      c=kbdin();
      videocursor(0,0,3); videoputc(c,2);
      videocursor(0,0,4); videoputc(' ',2);
      videocursor(0,5,0);
      switch (c) {

    case 'a': scrstr("northwest    "); pass1(aa,0); break;
    case 'b': scrstr("north        "); pass1(aa,1); break;
    case 'c': scrstr("northeast    "); pass1(aa,2); break;
    case 'd': scrstr("west         "); pass1(aa,3); break;
    case 'e': scrstr("stationary   "); pass1(aa,4); break;
    case 'f': scrstr("east         "); pass1(aa,5); break;
    case 'g': scrstr("southwest    "); pass1(aa,6); break;
    case 'h': scrstr("south        "); pass1(aa,7); break;
    case 'i': scrstr("southeast    "); pass1(aa,8); break;
    case 'j': scrstr("super nw     "); pass1(aa,9); break;
    case 'k': scrstr("super ne     "); pass1(aa,10); break;
    case 'l': scrstr("super sw     "); pass1(aa,11); break;
    case 'm': scrstr("super se     "); pass1(aa,12); break;
    case 'n': scrstr("zeroes       "); pass1(aa,13); break;
    case 'o': scrstr("ones         "); pass1(aa,14); break;
    case 'p': prng(1); break;
    case 'q': prnz(aa); prnd(aa); break;
    case 't': strp(aa,aa); break;
    case '=': videocursor(0,6,0); pass4(aa); break;
    case '8': eipo(aa); break;

    case 'A': pass7(aa,1,1); break;
    case 'B': pass7(aa,2,1); break;
    case 'C': pass7(aa,3,1); break;
    case 'D': pass7(aa,4,1); break;
    case 'E': pass7(aa,5,1); break;
    case 'F': pass7(aa,6,1); break;
    case 'M': pass7(aa,1,0); break;
    case 'N': pass7(aa,2,0); break;
    case 'O': pass7(aa,3,0); break;
    case 'P': pass7(aa,4,0); break;
    case 'Q': pass7(aa,5,0); break;
    case 'R': pass7(aa,6,0); break;
    case 'S': pass7(aa,7,0); break;
    case 'T': pass7(aa,8,0); break;

    default: break;}
     videocursor(0,0,3); videoputc(' ',2);
     videocursor(0,0,4); videoputc(' ',2);
     break;
  

    case '#': filp(aa,3); break;
    case '$': filp(aa,4); break;
    case '%': filp(aa,5); break;
    case '^': filp(aa,6); break;

    case 'g': onegen(arr1); screen(arr1); break;
    case 'z': clmat(); break;
    case 'Z': videoscroll(0,0,24,39,0,0); break;
    case '?': case '/': clijn(); break;
    default: break;
    }	/* end switch */
  }	/* end while  */
videocursor(0,0,1); videoputc(' ',2);
videocursor(0,0,2); videoputc(' ',2);
videoscroll(1,0,24,39,0,0);
}	/* end edijn */

/* THREE31.C */

/* Pass 1 marks sequences conforming to some shift */

pass1(z,l) char z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; int l; {
int  i0, i1, i2, i3, i4, i5, i6, i7, i8;
int  j0, j1, j2, j3;
int  k, m;
asctobin();
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
  j0=binrule[i0][i1][i3][i4];
  j1=binrule[i1][i2][i4][i5];
  j2=binrule[i3][i4][i6][i7];
  j3=binrule[i4][i5][i7][i8];
  k=binrule[j0][j1][j2][j3];
switch (l) {
  case 0: m=i0; break;
  case 1: m=i1; break;
  case 2: m=i2; break;
  case 3: m=i3; break;
  case 4: m=i4; break;
  case 5: m=i5; break;
  case 6: m=i6; break;
  case 7: m=i7; break;
  case 8: m=i8; break;
  case 9: m=j0; break;
  case 10: m=j1; break;
  case 11: m=j2; break;
  case 12: m=j3; break;
  case 13: m=0;  break;
  case 14: m=1;  break;
  default: break;}
z[i0][i1][i2][i3][i4][i5][i3][i4][i5][i6][i7][i8]=k==m?1:0;
adot(bdex(i3,i4,i5,i6,i7,i8),bdex(i0,i1,i2,i3,i4,i5),k==m?1:2);
}}}}}}}}}
}

/* turn binary index into a coordinate */
int bdex(i0,i1,i2,i3,i4,i5) int i0, i1, i2, i3, i4, i5; {
return i5+KK*(i4+KK*(i3+KK*(i2+KK*(i1+KK*i0))));
}

/* turn three binary digits into a decimal number */
int tdex(i0,i1,i2) int i0, i1, i2; {return i2+KK*(i1+KK*i0);}

/* pass 4 - print the matrix elements of the connection matrix */
pass4(z) char z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int  i0, i1, i2, i3, i4, i5, i6, i7, i8;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
  for (i6=0; i6<KK; i6++) {
  for (i7=0; i7<KK; i7++) {
  for (i8=0; i8<KK; i8++) {
  if (z[i0][i1][i2][i3][i4][i5][i3][i4][i5][i6][i7][i8]!=0) 
     printf("%1d%1d%1d, ",tdex(i0,i1,i2),tdex(i3,i4,i5),tdex(i6,i7,i8));
  }}}
  printf("\n");
  }}}}}}
}

/* pass7 - get the loops of length l */
/* oc is used to mark links while locating pure loops.	*/
/* 4 indicates a viable link, add 1 for in link, 2 for	*/
/* out link. Thus links marked 7 survive until the next	*/
/* round, mark them 4, all else 0; then repeat until no	*/
/* 5's or 6's show.					*/

pass7(z,l,t) int *z, l, t; {
int  f, g, k, p, q;
char oc[NN][NN];	/* node count */
videoscroll(7,24,24,39,0,0);
videocursor(0,5,14); printf("width %1d.",l);
videocursor(0,7,25); printf("gen nodes links");
for (p=0; p<NN; p++) for (q=0; q<NN; q++) oc[p][q]=4;
k=0;
do {
  g=0; k++; no=0; lk=0;
  videoscroll(6,7,24,24,0,0);
  pass7x(z,oc,l,0,t);
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) {
    f=oc[p][q];
    if (f==7) no++;
    if (f==5||f==6) g=1;
    oc[p][q]=f==7?4:0;
    }
    videocursor(0,8+k%16,25); printf("%3d %5d %5d",k,no,lk);
  } while (g==1);
videocursor(0,24,0);
/* kwait(2);
/* pass7x(z,oc,l,3,t);
/* kwait(2);
*/

if (no<NN) {
  g=4;
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) oc[p][q]=(oc[p][q]==4)?g++:0;
  zerar(z);
  videoscroll(6,7,24,24,0,0);
  prng(1);
  pass7x(z,oc,l,1,t);
  return;
  }
if (no<2*NN) {
  g=4;
  for (p=0; p<NN; p++) for (q=0; q<NN; q++) oc[p][q]=(oc[p][q]==4)?g++:0;
  videoscroll(6,7,24,24,0,0);
  pass7x(z,oc,l,2,t);
  return;
  }
}

/* pass 7x - display the acceptable strings of length l */
pass7x(z,oc,l,s,t) char *oc; int *z, l, s, t; {
int i[PN], j[PN], r[QN][10];
int p;
if (l<1) return;
switch (t) {
  case 0:
    if (l>8) return;
    for (p=0; p<PN; p++) i[p]=0;
    for (p=0; p<PN; p++) j[p]=0;
    pass7a(z,oc,r,i,j,0,l,s);
    break;
  case 1:
    if (l>6) return;
    for (i[0]=0; i[0]<KK; i[0]++) {
    for (i[1]=0; i[1]<KK; i[1]++) {
    for (i[2]=0; i[2]<KK; i[2]++) {
    for (i[3]=0; i[3]<KK; i[3]++) {
    for (i[4]=0; i[4]<KK; i[4]++) {
    for (i[5]=0; i[5]<KK; i[5]++) {
      for (p=0; p<PN; p++) j[p]=i[p];
      pass7a(z,oc,r,i,j,0,l,s);
      }}}}}}
    break;
  default: break;
  }
}

/* pass 7a - recursive step in pass 7 */
pass7a(z,oc,r,i,j,k,l,s)
int  *i, *j, k, l, s;
int  r[QN][10];
int  z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
char oc[NN][NN];
{
int p, w, x, y, i0, i1, i2;
int jj0, jj1, jj2, jj3, jj4, jj5;
int p0, p1, p2, p3, p4, p5;
int q0, q1, q2, q3, q4, q5;
if (k<l) {
  jj0=j[0]; jj1=j[1]; jj2=j[2]; jj3=j[3]; jj4=j[4]; jj5=j[5];
  for (i0=0; i0<KK; i0++) {r[0][k]=i0;
  for (i1=0; i1<KK; i1++) {r[1][k]=i1;
  for (i2=0; i2<KK; i2++) {r[2][k]=i2;
    if (z[jj0][jj1][jj2][jj3][jj4][jj5][jj3][jj4][jj5][i0][i1][i2]!=0) {
      j[0]=jj3; j[1]=jj4; j[2]=jj5; j[3]=i0; j[4]=i1; j[5]=i2;
      pass7a(z,oc,r,i,j,k+1,l,s);}
    }}}
  return;}
for (p=0; p<PN; p++) if (i[p]!=j[p]) return;
for (p=0, w=0; p<l; p++) w=w*KK+r[0][p];
for (p=0, x=0; p<l; p++) x=x*KK+r[1][p];
for (p=0, y=0; p<l; p++) y=y*KK+r[2][p];
if ((oc[w][x]>=4)&&(oc[x][y]>=4)) {
  switch (s) {
    case 0:
      adot(2*w,2*x,1); adot(2*w+1,2*x+1,1); oc[w][x]|=1;
      adot(2*x+1,2*y,2); adot(2*x,2*y+1,2); oc[x][y]|=2;
      lk++; break;
    case 1: /* graph and linkage matrix - full numbering */
      p5=oc[w][x]-4;
      q5=oc[x][y]-4;
      adot(2*p5,2*q5,3); adot(2*p5+1,2*q5+1,3);
      adot(2*p5+1,2*q5,3); adot(2*p5,2*q5+1,3);
      p5=(0<l)?r[0][0]:0;
      p4=(1<l)?r[0][1]:0;
      p3=(2<l)?r[0][2]:0;
      p2=(3<l)?r[0][3]:0;
      p1=(4<l)?r[0][4]:0;
      p0=(5<l)?r[0][5]:0;
      q5=(0<l)?r[1][0]:0;
      q4=(1<l)?r[1][1]:0;
      q3=(2<l)?r[1][2]:0;
      q2=(3<l)?r[1][3]:0;
      q1=(4<l)?r[1][4]:0;
      q0=(5<l)?r[1][5]:0;
      z[p0][p1][p2][p3][p4][p5][q0][q1][q2][q3][q4][q5]=1;
      break;
    case 2:
      p5=oc[w][x]-4;
      q5=oc[x][y]-4;
      adot(p5,q5,3);
      break;
    case 3:
      printf("      ");
      if (l>1) for (p=0; p<l-1; p+=2)
        printf("%1.1X",((r[0][p]*KK+r[1][p])*KK+r[0][p+1])*KK+r[1][p+1]);
      if (l%2==1) printf("%1.1X",r[0][l-1]*KK+r[1][l-1]); printf(" ");
      if (l>1) for (p=0; p<l-1; p+=2)
	printf("%1.1X",((r[1][p]*KK+r[2][p])*KK+r[1][p+1])*KK+r[2][p+1]);
      if (l%2==1) printf("%1.1X",r[1][l-1]*KK+r[2][l-1]); printf(" - ");
      for (p=0; p<l; p++) printf("%1.1d",r[0][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[1][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[2][p]); kwait(0);
      break;
    case 4:
      p5=oc[w][x]-4;
      q5=oc[x][y]-4;
      adot(2*p5,2*q5,3); adot(2*p5+1,2*q5+1,3);
      adot(2*p5+1,2*q5,3); adot(2*p5,2*q5+1,3);
      p0=p5%KK; p5/=KK;
      p1=p5%KK; p5/=KK;
      p2=p5%KK; p5/=KK;
      p3=p5%KK; p5/=KK;
      p4=p5%KK; p5/=KK;
      q0=q5%KK; q5/=KK;
      q1=q5%KK; q5/=KK;
      q2=q5%KK; q5/=KK;
      q3=q5%KK; q5/=KK;
      q4=q5%KK; q5/=KK;
      z[p0][p1][p2][p3][p4][p5][q0][q1][q2][q3][q4][q5]=1;
      break;
    default: break;
  }} 
}

/* multiply two 6x6 matrices */
mprod(z,x,y) int x[NN][NN], y[NN][NN], z[NN][NN]; {
int i0, i1, i2;
for (i0=0; i0<NN; i0++) {
for (i2=0; i2<NN; i2++) {
  z[i0][i2]=0; 
  for (i1=0; i1<NN; i1++) {
    z[i0][i2]+=x[i0][i1]*y[i1][i2];
    }}}
}

/* fill a 6x6 array with zeroes */
zerar(z)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=0;

}

/* copy one 6x6 array to another */
mcopy(z,x)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=
    x[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];

}

/* show the array z as a set of dots on the videoscreen */
prnz(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int i, j, k;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) {
    i=bdex(j0,j1,j2,j3,j4,j5);
    j=bdex(i0,i1,i2,i3,i4,i5);
    k=z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];
    if (k==0) bbdot(i,j,1); else aadot(i,j,3);
    }}}}}}
  }}}}}}
}

/* show the outline of the array z as dots on the videoscreen */
prng(l) int l;{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int i, j;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
  for (j0=0; j0<KK; j0++) {
  for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) {
    i=bdex(j0,j1,j2,j3,j4,j5);
    j=bdex(i0,i1,i2,i3,i4,i5);
    adot(2*i,2*j,l);
    }}}}}}
  }}}}}}
}

/* calculate the trace of 6x6 z */
long int traz(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
long int k;
k=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  k+=z[i0][i1][i2][i3][i4][i5][i0][i1][i2][i3][i4][i5];
return k;
}

/* print the diagonal of the 6x6 array z */
prnd(z) char z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i, j, k, l, i0, i1, i2, i3, i4, i5;
l=0;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
    i=bdex(i0,i1,i2,i3,i4,i5);
    k=z[i0][i1][i2][i3][i4][i5][i0][i1][i2][i3][i4][i5];
    l+=k;
    j=k==0?1:3;
    aadot(i,i,j);
  }}}}}}
  videocursor(0,1,10);
  printf("%8u",z[0][0][0][0][0][0][0][0][0][0][0][0]);
  videocursor(0,1,20);
  printf("%8u",l);
}

/* number of cycles for six widths of 6x6 */
strp(aa,bb) char *aa, *bb; {
char  x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
mcopy(x,bb);
mprod(bb,aa,x);
prnz(bb);
prnd(bb);
}

/* calculate traces and (0,0) elements for first 9 powers of x */
eipo(x) char x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
char     y[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int      i;
long int traz();
videoscroll(7,25,24,39,0,0);
videocursor(0,7,25);
printf("%6u",x[0][0][0][0][0][0][0][0][0][0][0][0]);
printf(",%8lu",traz(x));
mcopy(y,x);
for (i=0; i<8; i++) {
  mprod(y,y,x);
  videocursor(0,8+i,25);
  printf("%6u",y[0][0][0][0][0][0][0][0][0][0][0][0]);
  printf(",%8lu",traz(y));
  }
}

/* end */
